=begin
#IMBAG API - van de LVBAG

#Dit is de [BAG API](https://zakelijk.kadaster.nl/-/bag-api) Individuele Bevragingen van de Landelijke Voorziening Basisregistratie Adressen en Gebouwen (LVBAG).                                         <br/>                                         Meer informatie over de Basisregistratie Adressen en Gebouwen is te vinden op de website van het [Ministerie van Binnenlandse Zaken en Koninkrijksrelaties](https://www.geobasisregistraties.nl/basisregistraties/adressen-en-gebouwen) en [Kadaster](https://zakelijk.kadaster.nl/bag).                                         <br/>                                         <br/>                                         De BAG API levert informatie conform de [BAG Catalogus 2018](https://www.geobasisregistraties.nl/documenten/publicatie/2018/03/12/catalogus-2018) en het informatiemodel IMBAG 2.0.                                         De API specificatie volgt de [Nederlandse API-Strategie](https://docs.geostandaarden.nl/api/API-Strategie) specificatie versie van 20200204 en is opgesteld in [OpenAPI Specificatie](https://www.forumstandaardisatie.nl/standaard/openapi-specification) (OAS) v3.                                         <br/>                                         Het standaard mediatype HAL (`application/hal+json`) wordt gebruikt. Dit is een mediatype voor het weergeven van resources en hun relaties via hyperlinks.                                         <br/>                                         <br/>                                         Deze API is vooral gericht op individuele bevragingen (op basis van de identificerende gegevens van een object).                                         Om gebruik te kunnen maken van de BAG API is een API key nodig, deze kan verkregen worden door het [aanvraagformulier](https://formulieren.kadaster.nl/aanvraag_bag_api_individuele_bevragingen_productie) in te vullen.                                         <br/>                                         <br/>                                         Voor vragen, neem contact op met de LVBAG beheerder o.v.v. BAG API 2.0. We zijn aan het kijken naar een geschikt medium hiervoor, mede ook om de API iteratief te kunnen opstellen of doorontwikkelen samen met de community. Als de API iets (nog) niet kan, wat u wel graag wilt, neem dan contact op.

The version of the OpenAPI document: 2.1.6

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.4.0-SNAPSHOT

=end

# Common files
require 'bag_kadaster_client/api_client'
require 'bag_kadaster_client/api_error'
require 'bag_kadaster_client/version'
require 'bag_kadaster_client/configuration'

# Models
require 'bag_kadaster_client/models/api_info'
require 'bag_kadaster_client/models/adres'
require 'bag_kadaster_client/models/adres_io'
require 'bag_kadaster_client/models/adres_io_all_of'
require 'bag_kadaster_client/models/adres_io_embedded'
require 'bag_kadaster_client/models/adres_io_hal'
require 'bag_kadaster_client/models/adres_io_hal_all_of'
require 'bag_kadaster_client/models/adres_io_hal_collection'
require 'bag_kadaster_client/models/adres_io_hal_collection_embedded'
require 'bag_kadaster_client/models/adres_io_links'
require 'bag_kadaster_client/models/adres_in_onderzoek'
require 'bag_kadaster_client/models/adres_uitgebreid'
require 'bag_kadaster_client/models/adres_uitgebreid_all_of'
require 'bag_kadaster_client/models/adres_uitgebreid_geconstateerd'
require 'bag_kadaster_client/models/adres_uitgebreid_geconstateerd_all_of'
require 'bag_kadaster_client/models/adres_uitgebreid_hal'
require 'bag_kadaster_client/models/adres_uitgebreid_hal_all_of'
require 'bag_kadaster_client/models/adres_uitgebreid_hal_collection'
require 'bag_kadaster_client/models/adres_uitgebreid_hal_collection_embedded'
require 'bag_kadaster_client/models/adres_uitgebreid_in_onderzoek'
require 'bag_kadaster_client/models/adres_uitgebreid_in_onderzoek_all_of'
require 'bag_kadaster_client/models/adres_uitgebreid_links'
require 'bag_kadaster_client/models/adresseerbaar_object'
require 'bag_kadaster_client/models/adresseerbaar_object_io_hal'
require 'bag_kadaster_client/models/adresseerbaar_object_lvc_io_hal_collection'
require 'bag_kadaster_client/models/adresseerbaar_object_lvc_io_hal_collection_embedded'
require 'bag_kadaster_client/models/adresseerbare_objecten_io_hal_collection'
require 'bag_kadaster_client/models/adresseerbare_objecten_io_hal_collection_embedded'
require 'bag_kadaster_client/models/bronhouder'
require 'bag_kadaster_client/models/bronhouder_hal'
require 'bag_kadaster_client/models/bronhouder_hal_collection'
require 'bag_kadaster_client/models/bronhouder_hal_collection_embedded'
require 'bag_kadaster_client/models/bronhouder_links'
require 'bag_kadaster_client/models/error'
require 'bag_kadaster_client/models/gebruiksdoel'
require 'bag_kadaster_client/models/geconstateerd'
require 'bag_kadaster_client/models/hal_collection_links'
require 'bag_kadaster_client/models/hal_link'
require 'bag_kadaster_client/models/hal_pagination_links'
require 'bag_kadaster_client/models/hal_pagination_links_all_of'
require 'bag_kadaster_client/models/hal_pagination_links_all_of_first'
require 'bag_kadaster_client/models/hal_pagination_links_all_of_last'
require 'bag_kadaster_client/models/hal_pagination_links_all_of_next'
require 'bag_kadaster_client/models/hal_pagination_links_all_of_previous'
require 'bag_kadaster_client/models/historie_in_onderzoek'
require 'bag_kadaster_client/models/in_onderzoek_ligplaats'
require 'bag_kadaster_client/models/in_onderzoek_nummeraanduiding'
require 'bag_kadaster_client/models/in_onderzoek_openbare_ruimte'
require 'bag_kadaster_client/models/in_onderzoek_pand'
require 'bag_kadaster_client/models/in_onderzoek_standplaats'
require 'bag_kadaster_client/models/in_onderzoek_verblijfsobject'
require 'bag_kadaster_client/models/in_onderzoek_woonplaats'
require 'bag_kadaster_client/models/indicatie'
require 'bag_kadaster_client/models/invalid_params'
require 'bag_kadaster_client/models/kenmerk_ligplaats_in_onderzoek'
require 'bag_kadaster_client/models/kenmerk_nummeraanduiding_in_onderzoek'
require 'bag_kadaster_client/models/kenmerk_openbare_ruimte_in_onderzoek'
require 'bag_kadaster_client/models/kenmerk_pand_in_onderzoek'
require 'bag_kadaster_client/models/kenmerk_standplaats_in_onderzoek'
require 'bag_kadaster_client/models/kenmerk_verblijfsobject_in_onderzoek'
require 'bag_kadaster_client/models/kenmerk_woonplaats_in_onderzoek'
require 'bag_kadaster_client/models/ligplaats_all_of'
require 'bag_kadaster_client/models/ligplaats_embedded'
require 'bag_kadaster_client/models/ligplaats_io_hal'
require 'bag_kadaster_client/models/ligplaats_io_hal_collection'
require 'bag_kadaster_client/models/ligplaats_io_hal_collection_embedded'
require 'bag_kadaster_client/models/ligplaats_io_lvc_hal_collection'
require 'bag_kadaster_client/models/ligplaats_io_lvc_hal_collection_embedded'
require 'bag_kadaster_client/models/ligplaats_links'
require 'bag_kadaster_client/models/multi_polygon'
require 'bag_kadaster_client/models/multi_surface'
require 'bag_kadaster_client/models/nummeraanduiding'
require 'bag_kadaster_client/models/nummeraanduiding_embedded'
require 'bag_kadaster_client/models/nummeraanduiding_io_hal'
require 'bag_kadaster_client/models/nummeraanduiding_io_hal_collection'
require 'bag_kadaster_client/models/nummeraanduiding_io_hal_collection_embedded'
require 'bag_kadaster_client/models/nummeraanduiding_io_lvc_hal_collection'
require 'bag_kadaster_client/models/nummeraanduiding_io_lvc_hal_collection_embedded'
require 'bag_kadaster_client/models/nummeraanduiding_links'
require 'bag_kadaster_client/models/openbare_ruimte'
require 'bag_kadaster_client/models/openbare_ruimte_embedded'
require 'bag_kadaster_client/models/openbare_ruimte_io_hal'
require 'bag_kadaster_client/models/openbare_ruimte_io_hal_collection'
require 'bag_kadaster_client/models/openbare_ruimte_io_hal_collection_embedded'
require 'bag_kadaster_client/models/openbare_ruimte_io_lvc_hal_collection'
require 'bag_kadaster_client/models/openbare_ruimte_io_lvc_hal_collection_embedded'
require 'bag_kadaster_client/models/openbare_ruimte_links'
require 'bag_kadaster_client/models/pand'
require 'bag_kadaster_client/models/pand_io_hal'
require 'bag_kadaster_client/models/pand_io_hal_collection'
require 'bag_kadaster_client/models/pand_io_hal_collection_embedded'
require 'bag_kadaster_client/models/pand_io_lvc_hal_collection'
require 'bag_kadaster_client/models/pand_io_lvc_hal_collection_embedded'
require 'bag_kadaster_client/models/pand_links'
require 'bag_kadaster_client/models/point'
require 'bag_kadaster_client/models/polygon'
require 'bag_kadaster_client/models/provincie'
require 'bag_kadaster_client/models/punt_of_vlak'
require 'bag_kadaster_client/models/standplaats_all_of'
require 'bag_kadaster_client/models/standplaats_embedded'
require 'bag_kadaster_client/models/standplaats_io_hal'
require 'bag_kadaster_client/models/standplaats_io_hal_collection'
require 'bag_kadaster_client/models/standplaats_io_hal_collection_embedded'
require 'bag_kadaster_client/models/standplaats_io_lvc_hal_collection'
require 'bag_kadaster_client/models/standplaats_io_lvc_hal_collection_embedded'
require 'bag_kadaster_client/models/standplaats_links'
require 'bag_kadaster_client/models/status_naamgeving'
require 'bag_kadaster_client/models/status_pand'
require 'bag_kadaster_client/models/status_plaats'
require 'bag_kadaster_client/models/status_verblijfsobject'
require 'bag_kadaster_client/models/status_woonplaats'
require 'bag_kadaster_client/models/surface'
require 'bag_kadaster_client/models/type_adresseerbaar_object'
require 'bag_kadaster_client/models/type_openbare_ruimte'
require 'bag_kadaster_client/models/verblijfsobject_all_of'
require 'bag_kadaster_client/models/verblijfsobject_embedded'
require 'bag_kadaster_client/models/verblijfsobject_io_hal'
require 'bag_kadaster_client/models/verblijfsobject_io_hal_collection'
require 'bag_kadaster_client/models/verblijfsobject_io_hal_collection_embedded'
require 'bag_kadaster_client/models/verblijfsobject_io_lvc_hal_collection'
require 'bag_kadaster_client/models/verblijfsobject_io_lvc_hal_collection_embedded'
require 'bag_kadaster_client/models/verblijfsobject_links'
require 'bag_kadaster_client/models/vlak_of_multivlak'
require 'bag_kadaster_client/models/voorkomen'
require 'bag_kadaster_client/models/woonplaats'
require 'bag_kadaster_client/models/woonplaats_embedded'
require 'bag_kadaster_client/models/woonplaats_io_hal'
require 'bag_kadaster_client/models/woonplaats_io_hal_collection'
require 'bag_kadaster_client/models/woonplaats_io_hal_collection_embedded'
require 'bag_kadaster_client/models/woonplaats_io_lvc_hal_collection'
require 'bag_kadaster_client/models/woonplaats_io_lvc_hal_collection_embedded'
require 'bag_kadaster_client/models/woonplaats_links'
require 'bag_kadaster_client/models/zoek_resultaat'
require 'bag_kadaster_client/models/zoek_resultaat_hal'
require 'bag_kadaster_client/models/zoek_resultaat_hal_all_of'
require 'bag_kadaster_client/models/zoek_resultaat_hal_collection'
require 'bag_kadaster_client/models/zoek_resultaat_hal_collection_embedded'
require 'bag_kadaster_client/models/zoek_resultaat_links'
require 'bag_kadaster_client/models/ligplaats'
require 'bag_kadaster_client/models/standplaats'
require 'bag_kadaster_client/models/verblijfsobject'

# APIs
require 'bag_kadaster_client/api/adres_api'
require 'bag_kadaster_client/api/adres_uitgebreid_api'
require 'bag_kadaster_client/api/adresseerbaar_object_api'
require 'bag_kadaster_client/api/algemene_informatie_api'
require 'bag_kadaster_client/api/bronhouder_api'
require 'bag_kadaster_client/api/ligplaats_api'
require 'bag_kadaster_client/api/nummeraanduiding_api'
require 'bag_kadaster_client/api/openbare_ruimte_api'
require 'bag_kadaster_client/api/pand_api'
require 'bag_kadaster_client/api/standplaats_api'
require 'bag_kadaster_client/api/verblijfsobject_api'
require 'bag_kadaster_client/api/woonplaats_api'

module BagKadasterClient
  class << self
    # Customize default settings for the SDK using block.
    #   BagKadasterClient.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
