=begin
#IMBAG API - van de LVBAG

#Dit is de [BAG API](https://zakelijk.kadaster.nl/-/bag-api) Individuele Bevragingen van de Landelijke Voorziening Basisregistratie Adressen en Gebouwen (LVBAG).                                         <br/>                                         Meer informatie over de Basisregistratie Adressen en Gebouwen is te vinden op de website van het [Ministerie van Binnenlandse Zaken en Koninkrijksrelaties](https://www.geobasisregistraties.nl/basisregistraties/adressen-en-gebouwen) en [Kadaster](https://zakelijk.kadaster.nl/bag).                                         <br/>                                         <br/>                                         De BAG API levert informatie conform de [BAG Catalogus 2018](https://www.geobasisregistraties.nl/documenten/publicatie/2018/03/12/catalogus-2018) en het informatiemodel IMBAG 2.0.                                         De API specificatie volgt de [Nederlandse API-Strategie](https://docs.geostandaarden.nl/api/API-Strategie) specificatie versie van 20200204 en is opgesteld in [OpenAPI Specificatie](https://www.forumstandaardisatie.nl/standaard/openapi-specification) (OAS) v3.                                         <br/>                                         Het standaard mediatype HAL (`application/hal+json`) wordt gebruikt. Dit is een mediatype voor het weergeven van resources en hun relaties via hyperlinks.                                         <br/>                                         <br/>                                         Deze API is vooral gericht op individuele bevragingen (op basis van de identificerende gegevens van een object).                                         Om gebruik te kunnen maken van de BAG API is een API key nodig, deze kan verkregen worden door het [aanvraagformulier](https://formulieren.kadaster.nl/aanvraag_bag_api_individuele_bevragingen_productie) in te vullen.                                         <br/>                                         <br/>                                         Voor vragen, neem contact op met de LVBAG beheerder o.v.v. BAG API 2.0. We zijn aan het kijken naar een geschikt medium hiervoor, mede ook om de API iteratief te kunnen opstellen of doorontwikkelen samen met de community. Als de API iets (nog) niet kan, wat u wel graag wilt, neem dan contact op.

The version of the OpenAPI document: 2.1.6

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.4.0-SNAPSHOT

=end

require 'cgi'

module BagKadasterClient
  class AdresApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Bevragen van huidige adressen met een (combinatie van) zoek parameters.
    # De volgende bevragingen worden ondersteund: <ol>   <li>     Bevragen van één huidig adres met de identificatie van een zoekresultaat verkregen via /adressen/zoek.   </li>   <li>     Bevragen van één of meer huidige adressen met postcode, huisnummer en optioneel huisnummertoevoeging en huisletter.     Parameter exacteMatch kan worden toegepast.   </li>   <li>     Bevragen van één of meer huidige adressen met de identificatie van een adresseerbaar object.   </li>   <li>     Bevragen van één of meer huidige adressen met woonplaats naam, openbare ruimte naam, huisnummer en optioneel huisnummertoevoeging en/of huisletter.     Parameter exacteMatch kan worden toegepast.   </li>   <li>     Bevragen van één of meer huidige adressen met de identificatie van een pand.     Expand wordt niet ondersteund.   </li> </ol> Bij de bovenstaande bevragingen kunnen eveneens de volgende parameters worden gebruikt (tenzij anders vermeld):<br/> Als expand=nummeraanduiding, openbareRuimte, woonplaats (of een combinatie daarvan) of als expand=true, dan worden de gevraagde of alle gerelateerde resources als geneste resource geleverd. Voor paginering, zie: [functionele specificatie paginering](https://github.com/lvbag/BAG-API/blob/master/Features/paginering.feature).
    # @param [Hash] opts the optional parameters
    # @option opts [String] :zoekresultaat_identificatie De identificatie van een gekozen zoekresultaat uit de zoekResultatenHalCollectie verkregen bij een GET /adressen/zoek
    # @option opts [String] :postcode Postcode behorende bij een nummeraanduiding.
    # @option opts [Integer] :huisnummer Huisnummer behorende bij een nummeraanduiding.
    # @option opts [String] :huisnummertoevoeging Huisnummertoevoeging behorende bij een nummeraanduiding.
    # @option opts [String] :huisletter Huisletter behorende bij een nummeraanduiding.
    # @option opts [Boolean] :exacte_match \&quot;Een indicatie of de resultaten van een zoekoperatie exact overeen moeten komen met de zoekcriteria, zie [functionele specificatie exacte match](https://github.com/lvbag/BAG-API/blob/master/Features/exacte_match.feature).\&quot; (default to false)
    # @option opts [String] :adresseerbaar_object_identificatie Identificatie van een adresseerbaar object (ligplaats, standplaats of verblijfsobject) uit de BAG.
    # @option opts [String] :woonplaats_naam Naam van een woonplaats.
    # @option opts [String] :openbare_ruimte_naam Naam van een openbare ruimte.
    # @option opts [String] :pand_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @option opts [Integer] :page Pagina nummer (default to 1)
    # @option opts [Integer] :page_size Aantal resultaten per pagina (default to 20)
    # @return [AdresIOHalCollection]
    def bevraag_adressen(opts = {})
      data, _status_code, _headers = bevraag_adressen_with_http_info(opts)
      data
    end

    # Bevragen van huidige adressen met een (combinatie van) zoek parameters.
    # De volgende bevragingen worden ondersteund: &lt;ol&gt;   &lt;li&gt;     Bevragen van één huidig adres met de identificatie van een zoekresultaat verkregen via /adressen/zoek.   &lt;/li&gt;   &lt;li&gt;     Bevragen van één of meer huidige adressen met postcode, huisnummer en optioneel huisnummertoevoeging en huisletter.     Parameter exacteMatch kan worden toegepast.   &lt;/li&gt;   &lt;li&gt;     Bevragen van één of meer huidige adressen met de identificatie van een adresseerbaar object.   &lt;/li&gt;   &lt;li&gt;     Bevragen van één of meer huidige adressen met woonplaats naam, openbare ruimte naam, huisnummer en optioneel huisnummertoevoeging en/of huisletter.     Parameter exacteMatch kan worden toegepast.   &lt;/li&gt;   &lt;li&gt;     Bevragen van één of meer huidige adressen met de identificatie van een pand.     Expand wordt niet ondersteund.   &lt;/li&gt; &lt;/ol&gt; Bij de bovenstaande bevragingen kunnen eveneens de volgende parameters worden gebruikt (tenzij anders vermeld):&lt;br/&gt; Als expand&#x3D;nummeraanduiding, openbareRuimte, woonplaats (of een combinatie daarvan) of als expand&#x3D;true, dan worden de gevraagde of alle gerelateerde resources als geneste resource geleverd. Voor paginering, zie: [functionele specificatie paginering](https://github.com/lvbag/BAG-API/blob/master/Features/paginering.feature).
    # @param [Hash] opts the optional parameters
    # @option opts [String] :zoekresultaat_identificatie De identificatie van een gekozen zoekresultaat uit de zoekResultatenHalCollectie verkregen bij een GET /adressen/zoek
    # @option opts [String] :postcode Postcode behorende bij een nummeraanduiding.
    # @option opts [Integer] :huisnummer Huisnummer behorende bij een nummeraanduiding.
    # @option opts [String] :huisnummertoevoeging Huisnummertoevoeging behorende bij een nummeraanduiding.
    # @option opts [String] :huisletter Huisletter behorende bij een nummeraanduiding.
    # @option opts [Boolean] :exacte_match \&quot;Een indicatie of de resultaten van een zoekoperatie exact overeen moeten komen met de zoekcriteria, zie [functionele specificatie exacte match](https://github.com/lvbag/BAG-API/blob/master/Features/exacte_match.feature).\&quot;
    # @option opts [String] :adresseerbaar_object_identificatie Identificatie van een adresseerbaar object (ligplaats, standplaats of verblijfsobject) uit de BAG.
    # @option opts [String] :woonplaats_naam Naam van een woonplaats.
    # @option opts [String] :openbare_ruimte_naam Naam van een openbare ruimte.
    # @option opts [String] :pand_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @option opts [Integer] :page Pagina nummer
    # @option opts [Integer] :page_size Aantal resultaten per pagina
    # @return [Array<(AdresIOHalCollection, Integer, Hash)>] AdresIOHalCollection data, response status code and response headers
    def bevraag_adressen_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AdresApi.bevraag_adressen ...'
      end
      if @api_client.config.client_side_validation && !opts[:'zoekresultaat_identificatie'].nil? && opts[:'zoekresultaat_identificatie'].to_s.length > 255
        fail ArgumentError, 'invalid value for "opts[:"zoekresultaat_identificatie"]" when calling AdresApi.bevraag_adressen, the character length must be smaller than or equal to 255.'
      end

      if @api_client.config.client_side_validation && !opts[:'zoekresultaat_identificatie'].nil? && opts[:'zoekresultaat_identificatie'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"zoekresultaat_identificatie"]" when calling AdresApi.bevraag_adressen, the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/^[1-9]{1}[0-9]{3}[ ]{0,1}[a-zA-Z]{2}$/)
      if @api_client.config.client_side_validation && !opts[:'postcode'].nil? && opts[:'postcode'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"postcode\"]' when calling AdresApi.bevraag_adressen, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'huisnummer'].nil? && opts[:'huisnummer'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"huisnummer"]" when calling AdresApi.bevraag_adressen, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'huisnummer'].nil? && opts[:'huisnummer'] < 1
        fail ArgumentError, 'invalid value for "opts[:"huisnummer"]" when calling AdresApi.bevraag_adressen, must be greater than or equal to 1.'
      end

      pattern = Regexp.new(/^[0-9a-zA-Z]{1,4}$/)
      if @api_client.config.client_side_validation && !opts[:'huisnummertoevoeging'].nil? && opts[:'huisnummertoevoeging'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"huisnummertoevoeging\"]' when calling AdresApi.bevraag_adressen, must conform to the pattern #{pattern}."
      end

      pattern = Regexp.new(/^[a-zA-Z]{1}$/)
      if @api_client.config.client_side_validation && !opts[:'huisletter'].nil? && opts[:'huisletter'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"huisletter\"]' when calling AdresApi.bevraag_adressen, must conform to the pattern #{pattern}."
      end

      pattern = Regexp.new(/^[0-9]{4}(01|02|03)[0-9]{10}$/)
      if @api_client.config.client_side_validation && !opts[:'adresseerbaar_object_identificatie'].nil? && opts[:'adresseerbaar_object_identificatie'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"adresseerbaar_object_identificatie\"]' when calling AdresApi.bevraag_adressen, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'woonplaats_naam'].nil? && opts[:'woonplaats_naam'].to_s.length > 80
        fail ArgumentError, 'invalid value for "opts[:"woonplaats_naam"]" when calling AdresApi.bevraag_adressen, the character length must be smaller than or equal to 80.'
      end

      if @api_client.config.client_side_validation && !opts[:'woonplaats_naam'].nil? && opts[:'woonplaats_naam'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"woonplaats_naam"]" when calling AdresApi.bevraag_adressen, the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if @api_client.config.client_side_validation && !opts[:'woonplaats_naam'].nil? && opts[:'woonplaats_naam'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"woonplaats_naam\"]' when calling AdresApi.bevraag_adressen, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'openbare_ruimte_naam'].nil? && opts[:'openbare_ruimte_naam'].to_s.length > 80
        fail ArgumentError, 'invalid value for "opts[:"openbare_ruimte_naam"]" when calling AdresApi.bevraag_adressen, the character length must be smaller than or equal to 80.'
      end

      if @api_client.config.client_side_validation && !opts[:'openbare_ruimte_naam'].nil? && opts[:'openbare_ruimte_naam'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"openbare_ruimte_naam"]" when calling AdresApi.bevraag_adressen, the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if @api_client.config.client_side_validation && !opts[:'openbare_ruimte_naam'].nil? && opts[:'openbare_ruimte_naam'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"openbare_ruimte_naam\"]' when calling AdresApi.bevraag_adressen, must conform to the pattern #{pattern}."
      end

      pattern = Regexp.new(/^[0-9]{4}10[0-9]{10}$/)
      if @api_client.config.client_side_validation && !opts[:'pand_identificatie'].nil? && opts[:'pand_identificatie'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"pand_identificatie\"]' when calling AdresApi.bevraag_adressen, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'page'].nil? && opts[:'page'] < 1
        fail ArgumentError, 'invalid value for "opts[:"page"]" when calling AdresApi.bevraag_adressen, must be greater than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 100
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AdresApi.bevraag_adressen, must be smaller than or equal to 100.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 10
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AdresApi.bevraag_adressen, must be greater than or equal to 10.'
      end

      # resource path
      local_var_path = '/adressen'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'zoekresultaatIdentificatie'] = opts[:'zoekresultaat_identificatie'] if !opts[:'zoekresultaat_identificatie'].nil?
      query_params[:'postcode'] = opts[:'postcode'] if !opts[:'postcode'].nil?
      query_params[:'huisnummer'] = opts[:'huisnummer'] if !opts[:'huisnummer'].nil?
      query_params[:'huisnummertoevoeging'] = opts[:'huisnummertoevoeging'] if !opts[:'huisnummertoevoeging'].nil?
      query_params[:'huisletter'] = opts[:'huisletter'] if !opts[:'huisletter'].nil?
      query_params[:'exacteMatch'] = opts[:'exacte_match'] if !opts[:'exacte_match'].nil?
      query_params[:'adresseerbaarObjectIdentificatie'] = opts[:'adresseerbaar_object_identificatie'] if !opts[:'adresseerbaar_object_identificatie'].nil?
      query_params[:'woonplaatsNaam'] = opts[:'woonplaats_naam'] if !opts[:'woonplaats_naam'].nil?
      query_params[:'openbareRuimteNaam'] = opts[:'openbare_ruimte_naam'] if !opts[:'openbare_ruimte_naam'].nil?
      query_params[:'pandIdentificatie'] = opts[:'pand_identificatie'] if !opts[:'pand_identificatie'].nil?
      query_params[:'expand'] = opts[:'expand'] if !opts[:'expand'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'AdresIOHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"AdresApi.bevraag_adressen",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AdresApi#bevraag_adressen\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Bevragen van een huidig adres met de identificatie van een nummeraanduiding.
    # Bevragen van een huidig adres met de identificatie van een nummeraanduiding. Als expand=nummeraanduiding, openbareRuimte, woonplaats (of een combinatie daarvan) of als expand=true, dan worden de gevraagde of alle gerelateerde resources als geneste resource geleverd.
    # @param nummeraanduiding_identificatie [String] Identificatie van een nummeraanduiding uit de BAG. Deze is 16 cijfers lang.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @return [AdresIOHal]
    def bevraag_adressen_met_num_id(nummeraanduiding_identificatie, opts = {})
      data, _status_code, _headers = bevraag_adressen_met_num_id_with_http_info(nummeraanduiding_identificatie, opts)
      data
    end

    # Bevragen van een huidig adres met de identificatie van een nummeraanduiding.
    # Bevragen van een huidig adres met de identificatie van een nummeraanduiding. Als expand&#x3D;nummeraanduiding, openbareRuimte, woonplaats (of een combinatie daarvan) of als expand&#x3D;true, dan worden de gevraagde of alle gerelateerde resources als geneste resource geleverd.
    # @param nummeraanduiding_identificatie [String] Identificatie van een nummeraanduiding uit de BAG. Deze is 16 cijfers lang.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @return [Array<(AdresIOHal, Integer, Hash)>] AdresIOHal data, response status code and response headers
    def bevraag_adressen_met_num_id_with_http_info(nummeraanduiding_identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AdresApi.bevraag_adressen_met_num_id ...'
      end
      # verify the required parameter 'nummeraanduiding_identificatie' is set
      if @api_client.config.client_side_validation && nummeraanduiding_identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'nummeraanduiding_identificatie' when calling AdresApi.bevraag_adressen_met_num_id"
      end
      pattern = Regexp.new(/^[0-9]{16}$/)
      if @api_client.config.client_side_validation && nummeraanduiding_identificatie !~ pattern
        fail ArgumentError, "invalid value for 'nummeraanduiding_identificatie' when calling AdresApi.bevraag_adressen_met_num_id, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/adressen/{nummeraanduidingIdentificatie}'.sub('{' + 'nummeraanduidingIdentificatie' + '}', CGI.escape(nummeraanduiding_identificatie.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'expand'] = opts[:'expand'] if !opts[:'expand'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'AdresIOHal'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"AdresApi.bevraag_adressen_met_num_id",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AdresApi#bevraag_adressen_met_num_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Zoeken van huidige adressen
    # Zoeken van huidige adressen met postcode, woonplaats, straatnaam, huisnummer, huisletter, huisnummertoevoeging.  Een adres kan worden gevonden door de zoekresultaatidentificatie uit het antwoord als parameter mee te geven in get /adressen. Voor paginering, zie: [functionele specificatie paginering](https://github.com/lvbag/BAG-API/blob/master/Features/paginering.feature).
    # @param zoek [String] Zoekterm op postcode, woonplaats, straatnaam, huisnummer, huisletter, huisnummertoevoeging
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Pagina nummer (default to 1)
    # @option opts [Integer] :page_size Aantal resultaten per pagina (default to 20)
    # @return [ZoekResultaatHalCollection]
    def zoek(zoek, opts = {})
      data, _status_code, _headers = zoek_with_http_info(zoek, opts)
      data
    end

    # Zoeken van huidige adressen
    # Zoeken van huidige adressen met postcode, woonplaats, straatnaam, huisnummer, huisletter, huisnummertoevoeging.  Een adres kan worden gevonden door de zoekresultaatidentificatie uit het antwoord als parameter mee te geven in get /adressen. Voor paginering, zie: [functionele specificatie paginering](https://github.com/lvbag/BAG-API/blob/master/Features/paginering.feature).
    # @param zoek [String] Zoekterm op postcode, woonplaats, straatnaam, huisnummer, huisletter, huisnummertoevoeging
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Pagina nummer
    # @option opts [Integer] :page_size Aantal resultaten per pagina
    # @return [Array<(ZoekResultaatHalCollection, Integer, Hash)>] ZoekResultaatHalCollection data, response status code and response headers
    def zoek_with_http_info(zoek, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AdresApi.zoek ...'
      end
      # verify the required parameter 'zoek' is set
      if @api_client.config.client_side_validation && zoek.nil?
        fail ArgumentError, "Missing the required parameter 'zoek' when calling AdresApi.zoek"
      end
      if @api_client.config.client_side_validation && zoek.to_s.length > 255
        fail ArgumentError, 'invalid value for "zoek" when calling AdresApi.zoek, the character length must be smaller than or equal to 255.'
      end

      if @api_client.config.client_side_validation && zoek.to_s.length < 1
        fail ArgumentError, 'invalid value for "zoek" when calling AdresApi.zoek, the character length must be great than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'page'].nil? && opts[:'page'] < 1
        fail ArgumentError, 'invalid value for "opts[:"page"]" when calling AdresApi.zoek, must be greater than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 100
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AdresApi.zoek, must be smaller than or equal to 100.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 10
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AdresApi.zoek, must be greater than or equal to 10.'
      end

      # resource path
      local_var_path = '/adressen/zoek'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'zoek'] = zoek
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ZoekResultaatHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"AdresApi.zoek",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AdresApi#zoek\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
