=begin
#IMBAG API - van de LVBAG

#Dit is de [BAG API](https://zakelijk.kadaster.nl/-/bag-api) Individuele Bevragingen van de Landelijke Voorziening Basisregistratie Adressen en Gebouwen (LVBAG).                                         <br/>                                         Meer informatie over de Basisregistratie Adressen en Gebouwen is te vinden op de website van het [Ministerie van Binnenlandse Zaken en Koninkrijksrelaties](https://www.geobasisregistraties.nl/basisregistraties/adressen-en-gebouwen) en [Kadaster](https://zakelijk.kadaster.nl/bag).                                         <br/>                                         <br/>                                         De BAG API levert informatie conform de [BAG Catalogus 2018](https://www.geobasisregistraties.nl/documenten/publicatie/2018/03/12/catalogus-2018) en het informatiemodel IMBAG 2.0.                                         De API specificatie volgt de [Nederlandse API-Strategie](https://docs.geostandaarden.nl/api/API-Strategie) specificatie versie van 20200204 en is opgesteld in [OpenAPI Specificatie](https://www.forumstandaardisatie.nl/standaard/openapi-specification) (OAS) v3.                                         <br/>                                         Het standaard mediatype HAL (`application/hal+json`) wordt gebruikt. Dit is een mediatype voor het weergeven van resources en hun relaties via hyperlinks.                                         <br/>                                         <br/>                                         Deze API is vooral gericht op individuele bevragingen (op basis van de identificerende gegevens van een object).                                         Om gebruik te kunnen maken van de BAG API is een API key nodig, deze kan verkregen worden door het [aanvraagformulier](https://formulieren.kadaster.nl/aanvraag_bag_api_individuele_bevragingen_productie) in te vullen.                                         <br/>                                         <br/>                                         Voor vragen, neem contact op met de LVBAG beheerder o.v.v. BAG API 2.0. We zijn aan het kijken naar een geschikt medium hiervoor, mede ook om de API iteratief te kunnen opstellen of doorontwikkelen samen met de community. Als de API iets (nog) niet kan, wat u wel graag wilt, neem dan contact op.

The version of the OpenAPI document: 2.1.6

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.4.0-SNAPSHOT

=end

require 'cgi'

module BagKadasterClient
  class AdresseerbaarObjectApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Bevragen van één adresseerbaar object met een adresseerbaar object identificatie.
    # Bevragen van één adresseerbaar object (ligplaats, standplaats of verblijfsobject) met de identificatie van een adresseerbaar object. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.  Als expand=heeftAlsHoofdAdres, heeftAlsNevenAdres, maaktDeelUitVan (of een combinatie daarvan) of als expand=true, dan worden de gevraagde of alle gerelateerde resources als geneste resource geleverd.
    # @param adresseerbaar_object_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn gekomen op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39;. Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [AdresseerbaarObjectIOHal]
    def bevragen_adresseerbaar_object(adresseerbaar_object_identificatie, opts = {})
      data, _status_code, _headers = bevragen_adresseerbaar_object_with_http_info(adresseerbaar_object_identificatie, opts)
      data
    end

    # Bevragen van één adresseerbaar object met een adresseerbaar object identificatie.
    # Bevragen van één adresseerbaar object (ligplaats, standplaats of verblijfsobject) met de identificatie van een adresseerbaar object. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.  Als expand&#x3D;heeftAlsHoofdAdres, heeftAlsNevenAdres, maaktDeelUitVan (of een combinatie daarvan) of als expand&#x3D;true, dan worden de gevraagde of alle gerelateerde resources als geneste resource geleverd.
    # @param adresseerbaar_object_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn gekomen op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39;. Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [Array<(AdresseerbaarObjectIOHal, Integer, Hash)>] AdresseerbaarObjectIOHal data, response status code and response headers
    def bevragen_adresseerbaar_object_with_http_info(adresseerbaar_object_identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AdresseerbaarObjectApi.bevragen_adresseerbaar_object ...'
      end
      # verify the required parameter 'adresseerbaar_object_identificatie' is set
      if @api_client.config.client_side_validation && adresseerbaar_object_identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'adresseerbaar_object_identificatie' when calling AdresseerbaarObjectApi.bevragen_adresseerbaar_object"
      end
      pattern = Regexp.new(/^[0-9]{4}(01|02|03)[0-9]{10}$/)
      if @api_client.config.client_side_validation && adresseerbaar_object_identificatie !~ pattern
        fail ArgumentError, "invalid value for 'adresseerbaar_object_identificatie' when calling AdresseerbaarObjectApi.bevragen_adresseerbaar_object, must conform to the pattern #{pattern}."
      end

      allowable_values = ["epsg:28992"]
      if @api_client.config.client_side_validation && opts[:'accept_crs'] && !allowable_values.include?(opts[:'accept_crs'])
        fail ArgumentError, "invalid value for \"accept_crs\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/adresseerbareobjecten/{adresseerbaarObjectIdentificatie}'.sub('{' + 'adresseerbaarObjectIdentificatie' + '}', CGI.escape(adresseerbaar_object_identificatie.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'geldigOp'] = opts[:'geldig_op'] if !opts[:'geldig_op'].nil?
      query_params[:'beschikbaarOp'] = opts[:'beschikbaar_op'] if !opts[:'beschikbaar_op'].nil?
      query_params[:'expand'] = opts[:'expand'] if !opts[:'expand'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])
      header_params[:'Accept-Crs'] = opts[:'accept_crs'] if !opts[:'accept_crs'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'AdresseerbaarObjectIOHal'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"AdresseerbaarObjectApi.bevragen_adresseerbaar_object",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AdresseerbaarObjectApi#bevragen_adresseerbaar_object\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Bevragen van de levenscyclus van een adresseerbaar object met een adresseerbaar object identificatie.
    # Bevragen van de levenscyclus van een adresseerbaar object (ligplaats, standplaats of verblijfsobject) met de identificatie van een adresseerbaar object. Met de geheleLvc parameter kan worden aangegeven of de gehele levenscyclus (inclusief voorkomens die uit de geldige levenscyclus zijn verwijderd) of alleen de actieve levenscyclus (alleen de voorkomens die onderdeel zijn van de geldige levenscyclus) gewenst zijn. 
    # @param adresseerbaar_object_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :gehele_lvc Filtert naast geldige voorkomens ook de voorkomens die uit de geldige levenscyclus van het object zijn verwijderd. Als deze parameter wordt weggelaten worden alleen geldige voorkomens geretourneerd (default is false).  (default to false)
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [AdresseerbaarObjectLvcIOHalCollection]
    def bevragen_adresseerbaar_object_lvc(adresseerbaar_object_identificatie, opts = {})
      data, _status_code, _headers = bevragen_adresseerbaar_object_lvc_with_http_info(adresseerbaar_object_identificatie, opts)
      data
    end

    # Bevragen van de levenscyclus van een adresseerbaar object met een adresseerbaar object identificatie.
    # Bevragen van de levenscyclus van een adresseerbaar object (ligplaats, standplaats of verblijfsobject) met de identificatie van een adresseerbaar object. Met de geheleLvc parameter kan worden aangegeven of de gehele levenscyclus (inclusief voorkomens die uit de geldige levenscyclus zijn verwijderd) of alleen de actieve levenscyclus (alleen de voorkomens die onderdeel zijn van de geldige levenscyclus) gewenst zijn. 
    # @param adresseerbaar_object_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :gehele_lvc Filtert naast geldige voorkomens ook de voorkomens die uit de geldige levenscyclus van het object zijn verwijderd. Als deze parameter wordt weggelaten worden alleen geldige voorkomens geretourneerd (default is false). 
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [Array<(AdresseerbaarObjectLvcIOHalCollection, Integer, Hash)>] AdresseerbaarObjectLvcIOHalCollection data, response status code and response headers
    def bevragen_adresseerbaar_object_lvc_with_http_info(adresseerbaar_object_identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AdresseerbaarObjectApi.bevragen_adresseerbaar_object_lvc ...'
      end
      # verify the required parameter 'adresseerbaar_object_identificatie' is set
      if @api_client.config.client_side_validation && adresseerbaar_object_identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'adresseerbaar_object_identificatie' when calling AdresseerbaarObjectApi.bevragen_adresseerbaar_object_lvc"
      end
      pattern = Regexp.new(/^[0-9]{4}(01|02|03)[0-9]{10}$/)
      if @api_client.config.client_side_validation && adresseerbaar_object_identificatie !~ pattern
        fail ArgumentError, "invalid value for 'adresseerbaar_object_identificatie' when calling AdresseerbaarObjectApi.bevragen_adresseerbaar_object_lvc, must conform to the pattern #{pattern}."
      end

      allowable_values = ["epsg:28992"]
      if @api_client.config.client_side_validation && opts[:'accept_crs'] && !allowable_values.include?(opts[:'accept_crs'])
        fail ArgumentError, "invalid value for \"accept_crs\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/adresseerbareobjecten/{adresseerbaarObjectIdentificatie}/lvc'.sub('{' + 'adresseerbaarObjectIdentificatie' + '}', CGI.escape(adresseerbaar_object_identificatie.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'geheleLvc'] = opts[:'gehele_lvc'] if !opts[:'gehele_lvc'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])
      header_params[:'Accept-Crs'] = opts[:'accept_crs'] if !opts[:'accept_crs'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'AdresseerbaarObjectLvcIOHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"AdresseerbaarObjectApi.bevragen_adresseerbaar_object_lvc",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AdresseerbaarObjectApi#bevragen_adresseerbaar_object_lvc\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Bevragen van één of meer adresseerbare objecten op basis van een nummeraanduiding identificatie.
    # Bevragen/zoeken van alle aan een nummeraanduiding identificatie gerelateerde adresseerbare objecten (ligplaats, standplaats of verblijfsobject). Parameter huidig kan worden toegepast. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.  Als expand=heeftAlsHoofdAdres, heeftAlsNevenAdres, maaktDeelUitVan (of een combinatie daarvan) of als expand=true, dan worden de gevraagde of alle gerelateerde resources als geneste resource geleverd.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :nummeraanduiding_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @option opts [Boolean] :huidig Indicatie dat alleen actuele object voorkomens zonder eindstatus gewenst zijn. (default to false)
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn gekomen op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39;. Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [AdresseerbareObjectenIOHalCollection]
    def zoek_adresseerbaar_object(opts = {})
      data, _status_code, _headers = zoek_adresseerbaar_object_with_http_info(opts)
      data
    end

    # Bevragen van één of meer adresseerbare objecten op basis van een nummeraanduiding identificatie.
    # Bevragen/zoeken van alle aan een nummeraanduiding identificatie gerelateerde adresseerbare objecten (ligplaats, standplaats of verblijfsobject). Parameter huidig kan worden toegepast. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.  Als expand&#x3D;heeftAlsHoofdAdres, heeftAlsNevenAdres, maaktDeelUitVan (of een combinatie daarvan) of als expand&#x3D;true, dan worden de gevraagde of alle gerelateerde resources als geneste resource geleverd.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :nummeraanduiding_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @option opts [Boolean] :huidig Indicatie dat alleen actuele object voorkomens zonder eindstatus gewenst zijn.
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn gekomen op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39;. Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [Array<(AdresseerbareObjectenIOHalCollection, Integer, Hash)>] AdresseerbareObjectenIOHalCollection data, response status code and response headers
    def zoek_adresseerbaar_object_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AdresseerbaarObjectApi.zoek_adresseerbaar_object ...'
      end
      pattern = Regexp.new(/^[0-9]{4}20[0-9]{10}$/)
      if @api_client.config.client_side_validation && !opts[:'nummeraanduiding_identificatie'].nil? && opts[:'nummeraanduiding_identificatie'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"nummeraanduiding_identificatie\"]' when calling AdresseerbaarObjectApi.zoek_adresseerbaar_object, must conform to the pattern #{pattern}."
      end

      allowable_values = ["epsg:28992"]
      if @api_client.config.client_side_validation && opts[:'accept_crs'] && !allowable_values.include?(opts[:'accept_crs'])
        fail ArgumentError, "invalid value for \"accept_crs\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/adresseerbareobjecten'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'nummeraanduidingIdentificatie'] = opts[:'nummeraanduiding_identificatie'] if !opts[:'nummeraanduiding_identificatie'].nil?
      query_params[:'huidig'] = opts[:'huidig'] if !opts[:'huidig'].nil?
      query_params[:'geldigOp'] = opts[:'geldig_op'] if !opts[:'geldig_op'].nil?
      query_params[:'beschikbaarOp'] = opts[:'beschikbaar_op'] if !opts[:'beschikbaar_op'].nil?
      query_params[:'expand'] = opts[:'expand'] if !opts[:'expand'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])
      header_params[:'Accept-Crs'] = opts[:'accept_crs'] if !opts[:'accept_crs'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'AdresseerbareObjectenIOHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"AdresseerbaarObjectApi.zoek_adresseerbaar_object",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AdresseerbaarObjectApi#zoek_adresseerbaar_object\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
