=begin
#IMBAG API - van de LVBAG

#Dit is de [BAG API](https://zakelijk.kadaster.nl/-/bag-api) Individuele Bevragingen van de Landelijke Voorziening Basisregistratie Adressen en Gebouwen (LVBAG).                                         <br/>                                         Meer informatie over de Basisregistratie Adressen en Gebouwen is te vinden op de website van het [Ministerie van Binnenlandse Zaken en Koninkrijksrelaties](https://www.geobasisregistraties.nl/basisregistraties/adressen-en-gebouwen) en [Kadaster](https://zakelijk.kadaster.nl/bag).                                         <br/>                                         <br/>                                         De BAG API levert informatie conform de [BAG Catalogus 2018](https://www.geobasisregistraties.nl/documenten/publicatie/2018/03/12/catalogus-2018) en het informatiemodel IMBAG 2.0.                                         De API specificatie volgt de [Nederlandse API-Strategie](https://docs.geostandaarden.nl/api/API-Strategie) specificatie versie van 20200204 en is opgesteld in [OpenAPI Specificatie](https://www.forumstandaardisatie.nl/standaard/openapi-specification) (OAS) v3.                                         <br/>                                         Het standaard mediatype HAL (`application/hal+json`) wordt gebruikt. Dit is een mediatype voor het weergeven van resources en hun relaties via hyperlinks.                                         <br/>                                         <br/>                                         Deze API is vooral gericht op individuele bevragingen (op basis van de identificerende gegevens van een object).                                         Om gebruik te kunnen maken van de BAG API is een API key nodig, deze kan verkregen worden door het [aanvraagformulier](https://formulieren.kadaster.nl/aanvraag_bag_api_individuele_bevragingen_productie) in te vullen.                                         <br/>                                         <br/>                                         Voor vragen, neem contact op met de LVBAG beheerder o.v.v. BAG API 2.0. We zijn aan het kijken naar een geschikt medium hiervoor, mede ook om de API iteratief te kunnen opstellen of doorontwikkelen samen met de community. Als de API iets (nog) niet kan, wat u wel graag wilt, neem dan contact op.

The version of the OpenAPI document: 2.1.6

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.4.0-SNAPSHOT

=end

require 'cgi'

module BagKadasterClient
  class BronhouderApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Bevragen bronhouder met de bronhouder identificatie (gemeentecode).
    # Bevragen/raadplegen van een bronhouder met de identificatie van een bronhouder (gemeentecode). Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.
    # @param identificatie [String] Een officiële code die aan een gemeente is toegekend, ontleend is aan tabel 33.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @return [BronhouderHal]
    def bevragen_bronhouder(identificatie, opts = {})
      data, _status_code, _headers = bevragen_bronhouder_with_http_info(identificatie, opts)
      data
    end

    # Bevragen bronhouder met de bronhouder identificatie (gemeentecode).
    # Bevragen/raadplegen van een bronhouder met de identificatie van een bronhouder (gemeentecode). Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.
    # @param identificatie [String] Een officiële code die aan een gemeente is toegekend, ontleend is aan tabel 33.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @return [Array<(BronhouderHal, Integer, Hash)>] BronhouderHal data, response status code and response headers
    def bevragen_bronhouder_with_http_info(identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BronhouderApi.bevragen_bronhouder ...'
      end
      # verify the required parameter 'identificatie' is set
      if @api_client.config.client_side_validation && identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'identificatie' when calling BronhouderApi.bevragen_bronhouder"
      end
      pattern = Regexp.new(/^[0-9]{4}$/)
      if @api_client.config.client_side_validation && identificatie !~ pattern
        fail ArgumentError, "invalid value for 'identificatie' when calling BronhouderApi.bevragen_bronhouder, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/bronhouders/{identificatie}'.sub('{' + 'identificatie' + '}', CGI.escape(identificatie.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'geldigOp'] = opts[:'geldig_op'] if !opts[:'geldig_op'].nil?
      query_params[:'beschikbaarOp'] = opts[:'beschikbaar_op'] if !opts[:'beschikbaar_op'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'BronhouderHal'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"BronhouderApi.bevragen_bronhouder",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BronhouderApi#bevragen_bronhouder\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen voorkomen van een bronhouder met de identificatie van een bronhouder en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # Bevragen/raadplegen van een voorkomen van een bronhouder met de identificatie van een bronhouder en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # @param identificatie [String] Een officiële code die aan een gemeente is toegekend, ontleend is aan tabel 33.
    # @param versie [Integer] De versie van een voorkomen van een object
    # @param timestamp_registratie_lv [String] Een timestamp van het tijdstip waarop een voorkomen is geregistreerd in de LV BAG
    # @param [Hash] opts the optional parameters
    # @return [BronhouderHal]
    def bronhouder_identificatie_voorkomen(identificatie, versie, timestamp_registratie_lv, opts = {})
      data, _status_code, _headers = bronhouder_identificatie_voorkomen_with_http_info(identificatie, versie, timestamp_registratie_lv, opts)
      data
    end

    # bevragen voorkomen van een bronhouder met de identificatie van een bronhouder en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # Bevragen/raadplegen van een voorkomen van een bronhouder met de identificatie van een bronhouder en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # @param identificatie [String] Een officiële code die aan een gemeente is toegekend, ontleend is aan tabel 33.
    # @param versie [Integer] De versie van een voorkomen van een object
    # @param timestamp_registratie_lv [String] Een timestamp van het tijdstip waarop een voorkomen is geregistreerd in de LV BAG
    # @param [Hash] opts the optional parameters
    # @return [Array<(BronhouderHal, Integer, Hash)>] BronhouderHal data, response status code and response headers
    def bronhouder_identificatie_voorkomen_with_http_info(identificatie, versie, timestamp_registratie_lv, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BronhouderApi.bronhouder_identificatie_voorkomen ...'
      end
      # verify the required parameter 'identificatie' is set
      if @api_client.config.client_side_validation && identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'identificatie' when calling BronhouderApi.bronhouder_identificatie_voorkomen"
      end
      pattern = Regexp.new(/^[0-9]{4}$/)
      if @api_client.config.client_side_validation && identificatie !~ pattern
        fail ArgumentError, "invalid value for 'identificatie' when calling BronhouderApi.bronhouder_identificatie_voorkomen, must conform to the pattern #{pattern}."
      end

      # verify the required parameter 'versie' is set
      if @api_client.config.client_side_validation && versie.nil?
        fail ArgumentError, "Missing the required parameter 'versie' when calling BronhouderApi.bronhouder_identificatie_voorkomen"
      end
      # verify the required parameter 'timestamp_registratie_lv' is set
      if @api_client.config.client_side_validation && timestamp_registratie_lv.nil?
        fail ArgumentError, "Missing the required parameter 'timestamp_registratie_lv' when calling BronhouderApi.bronhouder_identificatie_voorkomen"
      end
      pattern = Regexp.new(/^\d+$/)
      if @api_client.config.client_side_validation && timestamp_registratie_lv !~ pattern
        fail ArgumentError, "invalid value for 'timestamp_registratie_lv' when calling BronhouderApi.bronhouder_identificatie_voorkomen, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/bronhouders/{identificatie}/{versie}/{timestampRegistratieLv}'.sub('{' + 'identificatie' + '}', CGI.escape(identificatie.to_s)).sub('{' + 'versie' + '}', CGI.escape(versie.to_s)).sub('{' + 'timestampRegistratieLv' + '}', CGI.escape(timestamp_registratie_lv.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'BronhouderHal'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"BronhouderApi.bronhouder_identificatie_voorkomen",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BronhouderApi#bronhouder_identificatie_voorkomen\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Bevragen bronhouder met een object identificatie.
    # Bevragen/raadplegen van een bronhouder met de identificatie van een object. De identificatie van één van de objecten: woonplaats, openbare ruimte, nummeraanduiding, ligplaats, standplaats, verblijfsobject of pand dient gespecificeerd te worden:<br/> Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :woonplaats_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @option opts [String] :object_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @return [BronhouderHalCollection]
    def zoek_bronhouder(opts = {})
      data, _status_code, _headers = zoek_bronhouder_with_http_info(opts)
      data
    end

    # Bevragen bronhouder met een object identificatie.
    # Bevragen/raadplegen van een bronhouder met de identificatie van een object. De identificatie van één van de objecten: woonplaats, openbare ruimte, nummeraanduiding, ligplaats, standplaats, verblijfsobject of pand dient gespecificeerd te worden:&lt;br/&gt; Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :woonplaats_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @option opts [String] :object_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @return [Array<(BronhouderHalCollection, Integer, Hash)>] BronhouderHalCollection data, response status code and response headers
    def zoek_bronhouder_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BronhouderApi.zoek_bronhouder ...'
      end
      pattern = Regexp.new(/[0-9]{3}[1-9]|[0-9]{2}[1-9][0-9]|[0-9][1-9][0-9]{2}|[1-9][0-9]{3}/)
      if @api_client.config.client_side_validation && !opts[:'woonplaats_identificatie'].nil? && opts[:'woonplaats_identificatie'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"woonplaats_identificatie\"]' when calling BronhouderApi.zoek_bronhouder, must conform to the pattern #{pattern}."
      end

      pattern = Regexp.new(/^[0-9]{4}(?:01|02|03|10|20|30)[0-9]{10}$|^[0-9]{3}[1-9]$|^[0-9]{2}[1-9][0-9]$|^[0-9][1-9][0-9]{2}$|^[1-9][0-9]{3}$/)
      if @api_client.config.client_side_validation && !opts[:'object_identificatie'].nil? && opts[:'object_identificatie'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"object_identificatie\"]' when calling BronhouderApi.zoek_bronhouder, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/bronhouders'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'woonplaatsIdentificatie'] = opts[:'woonplaats_identificatie'] if !opts[:'woonplaats_identificatie'].nil?
      query_params[:'objectIdentificatie'] = opts[:'object_identificatie'] if !opts[:'object_identificatie'].nil?
      query_params[:'geldigOp'] = opts[:'geldig_op'] if !opts[:'geldig_op'].nil?
      query_params[:'beschikbaarOp'] = opts[:'beschikbaar_op'] if !opts[:'beschikbaar_op'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'BronhouderHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"BronhouderApi.zoek_bronhouder",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BronhouderApi#zoek_bronhouder\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
