=begin
#IMBAG API - van de LVBAG

#Dit is de [BAG API](https://zakelijk.kadaster.nl/-/bag-api) Individuele Bevragingen van de Landelijke Voorziening Basisregistratie Adressen en Gebouwen (LVBAG).                                         <br/>                                         Meer informatie over de Basisregistratie Adressen en Gebouwen is te vinden op de website van het [Ministerie van Binnenlandse Zaken en Koninkrijksrelaties](https://www.geobasisregistraties.nl/basisregistraties/adressen-en-gebouwen) en [Kadaster](https://zakelijk.kadaster.nl/bag).                                         <br/>                                         <br/>                                         De BAG API levert informatie conform de [BAG Catalogus 2018](https://www.geobasisregistraties.nl/documenten/publicatie/2018/03/12/catalogus-2018) en het informatiemodel IMBAG 2.0.                                         De API specificatie volgt de [Nederlandse API-Strategie](https://docs.geostandaarden.nl/api/API-Strategie) specificatie versie van 20200204 en is opgesteld in [OpenAPI Specificatie](https://www.forumstandaardisatie.nl/standaard/openapi-specification) (OAS) v3.                                         <br/>                                         Het standaard mediatype HAL (`application/hal+json`) wordt gebruikt. Dit is een mediatype voor het weergeven van resources en hun relaties via hyperlinks.                                         <br/>                                         <br/>                                         Deze API is vooral gericht op individuele bevragingen (op basis van de identificerende gegevens van een object).                                         Om gebruik te kunnen maken van de BAG API is een API key nodig, deze kan verkregen worden door het [aanvraagformulier](https://formulieren.kadaster.nl/aanvraag_bag_api_individuele_bevragingen_productie) in te vullen.                                         <br/>                                         <br/>                                         Voor vragen, neem contact op met de LVBAG beheerder o.v.v. BAG API 2.0. We zijn aan het kijken naar een geschikt medium hiervoor, mede ook om de API iteratief te kunnen opstellen of doorontwikkelen samen met de community. Als de API iets (nog) niet kan, wat u wel graag wilt, neem dan contact op.

The version of the OpenAPI document: 2.1.6

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.4.0-SNAPSHOT

=end

require 'cgi'

module BagKadasterClient
  class NummeraanduidingApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # bevragen van een nummeraanduiding op basis van de identificatie van een nummeraanduiding
    # Bevragen/raadplegen van één nummeraanduiding met de identificatie van een nummeraanduiding. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.  Als expand=ligtInWoonplaats, ligtAanOpenbareRuimte of als expand=true dan worden de gevraagde of alle gerelateerde objecten als geneste resources geleverd. 
    # @param nummeraanduiding_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39;  Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @return [NummeraanduidingIOHal]
    def nummeraanduiding_identificatie(nummeraanduiding_identificatie, opts = {})
      data, _status_code, _headers = nummeraanduiding_identificatie_with_http_info(nummeraanduiding_identificatie, opts)
      data
    end

    # bevragen van een nummeraanduiding op basis van de identificatie van een nummeraanduiding
    # Bevragen/raadplegen van één nummeraanduiding met de identificatie van een nummeraanduiding. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.  Als expand&#x3D;ligtInWoonplaats, ligtAanOpenbareRuimte of als expand&#x3D;true dan worden de gevraagde of alle gerelateerde objecten als geneste resources geleverd. 
    # @param nummeraanduiding_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39;  Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @return [Array<(NummeraanduidingIOHal, Integer, Hash)>] NummeraanduidingIOHal data, response status code and response headers
    def nummeraanduiding_identificatie_with_http_info(nummeraanduiding_identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: NummeraanduidingApi.nummeraanduiding_identificatie ...'
      end
      # verify the required parameter 'nummeraanduiding_identificatie' is set
      if @api_client.config.client_side_validation && nummeraanduiding_identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'nummeraanduiding_identificatie' when calling NummeraanduidingApi.nummeraanduiding_identificatie"
      end
      pattern = Regexp.new(/^[0-9]{4}20[0-9]{10}$/)
      if @api_client.config.client_side_validation && nummeraanduiding_identificatie !~ pattern
        fail ArgumentError, "invalid value for 'nummeraanduiding_identificatie' when calling NummeraanduidingApi.nummeraanduiding_identificatie, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/nummeraanduidingen/{nummeraanduidingIdentificatie}'.sub('{' + 'nummeraanduidingIdentificatie' + '}', CGI.escape(nummeraanduiding_identificatie.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'geldigOp'] = opts[:'geldig_op'] if !opts[:'geldig_op'].nil?
      query_params[:'beschikbaarOp'] = opts[:'beschikbaar_op'] if !opts[:'beschikbaar_op'].nil?
      query_params[:'expand'] = opts[:'expand'] if !opts[:'expand'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'NummeraanduidingIOHal'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"NummeraanduidingApi.nummeraanduiding_identificatie",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: NummeraanduidingApi#nummeraanduiding_identificatie\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen van een voorkomen van een nummeraanduiding, op basis van de identificatie van een nummeraanduiding en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # Bevragen/raadplegen van een voorkomen van een nummeraanduiding met de identificatie van een nummeraanduiding en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # @param nummeraanduiding_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param versie [Integer] De versie van een voorkomen van een object
    # @param timestamp_registratie_lv [String] Een timestamp van het tijdstip waarop een voorkomen is geregistreerd in de LV BAG
    # @param [Hash] opts the optional parameters
    # @return [NummeraanduidingIOHal]
    def nummeraanduiding_identificatie_voorkomen(nummeraanduiding_identificatie, versie, timestamp_registratie_lv, opts = {})
      data, _status_code, _headers = nummeraanduiding_identificatie_voorkomen_with_http_info(nummeraanduiding_identificatie, versie, timestamp_registratie_lv, opts)
      data
    end

    # bevragen van een voorkomen van een nummeraanduiding, op basis van de identificatie van een nummeraanduiding en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # Bevragen/raadplegen van een voorkomen van een nummeraanduiding met de identificatie van een nummeraanduiding en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # @param nummeraanduiding_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param versie [Integer] De versie van een voorkomen van een object
    # @param timestamp_registratie_lv [String] Een timestamp van het tijdstip waarop een voorkomen is geregistreerd in de LV BAG
    # @param [Hash] opts the optional parameters
    # @return [Array<(NummeraanduidingIOHal, Integer, Hash)>] NummeraanduidingIOHal data, response status code and response headers
    def nummeraanduiding_identificatie_voorkomen_with_http_info(nummeraanduiding_identificatie, versie, timestamp_registratie_lv, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: NummeraanduidingApi.nummeraanduiding_identificatie_voorkomen ...'
      end
      # verify the required parameter 'nummeraanduiding_identificatie' is set
      if @api_client.config.client_side_validation && nummeraanduiding_identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'nummeraanduiding_identificatie' when calling NummeraanduidingApi.nummeraanduiding_identificatie_voorkomen"
      end
      pattern = Regexp.new(/^[0-9]{4}20[0-9]{10}$/)
      if @api_client.config.client_side_validation && nummeraanduiding_identificatie !~ pattern
        fail ArgumentError, "invalid value for 'nummeraanduiding_identificatie' when calling NummeraanduidingApi.nummeraanduiding_identificatie_voorkomen, must conform to the pattern #{pattern}."
      end

      # verify the required parameter 'versie' is set
      if @api_client.config.client_side_validation && versie.nil?
        fail ArgumentError, "Missing the required parameter 'versie' when calling NummeraanduidingApi.nummeraanduiding_identificatie_voorkomen"
      end
      # verify the required parameter 'timestamp_registratie_lv' is set
      if @api_client.config.client_side_validation && timestamp_registratie_lv.nil?
        fail ArgumentError, "Missing the required parameter 'timestamp_registratie_lv' when calling NummeraanduidingApi.nummeraanduiding_identificatie_voorkomen"
      end
      pattern = Regexp.new(/^\d+$/)
      if @api_client.config.client_side_validation && timestamp_registratie_lv !~ pattern
        fail ArgumentError, "invalid value for 'timestamp_registratie_lv' when calling NummeraanduidingApi.nummeraanduiding_identificatie_voorkomen, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/nummeraanduidingen/{nummeraanduidingIdentificatie}/{versie}/{timestampRegistratieLv}'.sub('{' + 'nummeraanduidingIdentificatie' + '}', CGI.escape(nummeraanduiding_identificatie.to_s)).sub('{' + 'versie' + '}', CGI.escape(versie.to_s)).sub('{' + 'timestampRegistratieLv' + '}', CGI.escape(timestamp_registratie_lv.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'NummeraanduidingIOHal'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"NummeraanduidingApi.nummeraanduiding_identificatie_voorkomen",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: NummeraanduidingApi#nummeraanduiding_identificatie_voorkomen\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen levenscyclus van een nummeraanduiding met de identificatie van een nummeraanduiding.
    # Bevragen/raadplegen van de levenscyclus van één nummeraanduiding met de identificatie van een nummeraanduiding. 
    # @param nummeraanduiding_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :gehele_lvc Filtert naast geldige voorkomens ook de voorkomens die uit de geldige levenscyclus van het object zijn verwijderd. Als deze parameter wordt weggelaten worden alleen geldige voorkomens geretourneerd (default is false). Voor een toelichting zie de [Praktijkhandleiding BAG](https://imbag.github.io/praktijkhandleiding/artikelen/wat-is-het-verschil-tussen-actieve-voorkomens-actuele-voorkomens-en-huidige-voorkomens). (default to false)
    # @return [NummeraanduidingIOLvcHalCollection]
    def nummeraanduiding_lvc_identificatie(nummeraanduiding_identificatie, opts = {})
      data, _status_code, _headers = nummeraanduiding_lvc_identificatie_with_http_info(nummeraanduiding_identificatie, opts)
      data
    end

    # bevragen levenscyclus van een nummeraanduiding met de identificatie van een nummeraanduiding.
    # Bevragen/raadplegen van de levenscyclus van één nummeraanduiding met de identificatie van een nummeraanduiding. 
    # @param nummeraanduiding_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :gehele_lvc Filtert naast geldige voorkomens ook de voorkomens die uit de geldige levenscyclus van het object zijn verwijderd. Als deze parameter wordt weggelaten worden alleen geldige voorkomens geretourneerd (default is false). Voor een toelichting zie de [Praktijkhandleiding BAG](https://imbag.github.io/praktijkhandleiding/artikelen/wat-is-het-verschil-tussen-actieve-voorkomens-actuele-voorkomens-en-huidige-voorkomens).
    # @return [Array<(NummeraanduidingIOLvcHalCollection, Integer, Hash)>] NummeraanduidingIOLvcHalCollection data, response status code and response headers
    def nummeraanduiding_lvc_identificatie_with_http_info(nummeraanduiding_identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: NummeraanduidingApi.nummeraanduiding_lvc_identificatie ...'
      end
      # verify the required parameter 'nummeraanduiding_identificatie' is set
      if @api_client.config.client_side_validation && nummeraanduiding_identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'nummeraanduiding_identificatie' when calling NummeraanduidingApi.nummeraanduiding_lvc_identificatie"
      end
      pattern = Regexp.new(/^[0-9]{4}20[0-9]{10}$/)
      if @api_client.config.client_side_validation && nummeraanduiding_identificatie !~ pattern
        fail ArgumentError, "invalid value for 'nummeraanduiding_identificatie' when calling NummeraanduidingApi.nummeraanduiding_lvc_identificatie, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/nummeraanduidingen/{nummeraanduidingIdentificatie}/lvc'.sub('{' + 'nummeraanduidingIdentificatie' + '}', CGI.escape(nummeraanduiding_identificatie.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'geheleLvc'] = opts[:'gehele_lvc'] if !opts[:'gehele_lvc'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'NummeraanduidingIOLvcHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"NummeraanduidingApi.nummeraanduiding_lvc_identificatie",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: NummeraanduidingApi#nummeraanduiding_lvc_identificatie\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen nummeraanduiding(en) op basis van verschillende combinaties van parameters.
    # De volgende (combinaties van) parameters worden ondersteund:  1. Bevragen/raadplegen van een (collectie van) nummeraanduiding(en) met postcode en huisnummer (evt. met huisletter en huisnummertoevoeging).  2. Bevragen/raadplegen van een (collectie van) nummeraanduiding(en) met woonplaats naam, openbare ruimte naam, huisnummer en optioneel huisnummertoevoeging en huisletter.  3. Bevragen/zoeken van alle aan een openbare ruimte gerelateerde nummeraanduidingen met een openbare ruimte identificatie.     Expand wordt niet ondersteund.     4. Bevragen/zoeken van nummeraanduidingen met een pand identificatie. Expand wordt niet ondersteund.         Bij de bovenstaande bevragingen kunnen (tenzij anders vermeld) de volgende parameters worden gebruikt: geldigOp, beschikbaarOp, huidig, page en pageSize.  Voor paginering, zie: [functionele specificatie paginering](https://github.com/lvbag/BAG-API/blob/master/Features/paginering.feature). Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd. Parameter huidig kan worden toegepast. Als expand=ligtInWoonplaats, ligtAanOpenbareRuimte of als expand=true dan worden de gevraagde of alle gerelateerde objecten als geneste resources geleverd.  Met de exacteMatch parameter kan worden aangegeven dat alleen object(en) die exact overeenkomen met de opgegeven parameters, geretourneerd moeten worden. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :postcode Postcode behorende bij een nummeraanduiding.
    # @option opts [Integer] :huisnummer Huisnummer behorende bij een nummeraanduiding.
    # @option opts [String] :huisnummertoevoeging Huisnummertoevoeging behorende bij een nummeraanduiding.
    # @option opts [String] :huisletter Huisletter behorende bij een nummeraanduiding.
    # @option opts [Boolean] :exacte_match \&quot;Een indicatie of de resultaten van een zoekoperatie exact overeen moeten komen met de zoekcriteria, zie [functionele specificatie exacte match](https://github.com/lvbag/BAG-API/blob/master/Features/exacte_match.feature).\&quot; (default to false)
    # @option opts [String] :woonplaats_naam Naam van een woonplaats.
    # @option opts [String] :openbare_ruimte_naam Naam van een openbare ruimte.
    # @option opts [String] :openbare_ruimte_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @option opts [Boolean] :huidig Indicatie dat alleen actuele object voorkomens zonder eindstatus gewenst zijn. (default to false)
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39;  Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Integer] :page Pagina nummer (default to 1)
    # @option opts [Integer] :page_size Aantal resultaten per pagina (default to 20)
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @option opts [String] :pand_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @return [NummeraanduidingIOHalCollection]
    def zoek_nummeraanduiding(opts = {})
      data, _status_code, _headers = zoek_nummeraanduiding_with_http_info(opts)
      data
    end

    # bevragen nummeraanduiding(en) op basis van verschillende combinaties van parameters.
    # De volgende (combinaties van) parameters worden ondersteund:  1. Bevragen/raadplegen van een (collectie van) nummeraanduiding(en) met postcode en huisnummer (evt. met huisletter en huisnummertoevoeging).  2. Bevragen/raadplegen van een (collectie van) nummeraanduiding(en) met woonplaats naam, openbare ruimte naam, huisnummer en optioneel huisnummertoevoeging en huisletter.  3. Bevragen/zoeken van alle aan een openbare ruimte gerelateerde nummeraanduidingen met een openbare ruimte identificatie.     Expand wordt niet ondersteund.     4. Bevragen/zoeken van nummeraanduidingen met een pand identificatie. Expand wordt niet ondersteund.         Bij de bovenstaande bevragingen kunnen (tenzij anders vermeld) de volgende parameters worden gebruikt: geldigOp, beschikbaarOp, huidig, page en pageSize.  Voor paginering, zie: [functionele specificatie paginering](https://github.com/lvbag/BAG-API/blob/master/Features/paginering.feature). Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd. Parameter huidig kan worden toegepast. Als expand&#x3D;ligtInWoonplaats, ligtAanOpenbareRuimte of als expand&#x3D;true dan worden de gevraagde of alle gerelateerde objecten als geneste resources geleverd.  Met de exacteMatch parameter kan worden aangegeven dat alleen object(en) die exact overeenkomen met de opgegeven parameters, geretourneerd moeten worden. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :postcode Postcode behorende bij een nummeraanduiding.
    # @option opts [Integer] :huisnummer Huisnummer behorende bij een nummeraanduiding.
    # @option opts [String] :huisnummertoevoeging Huisnummertoevoeging behorende bij een nummeraanduiding.
    # @option opts [String] :huisletter Huisletter behorende bij een nummeraanduiding.
    # @option opts [Boolean] :exacte_match \&quot;Een indicatie of de resultaten van een zoekoperatie exact overeen moeten komen met de zoekcriteria, zie [functionele specificatie exacte match](https://github.com/lvbag/BAG-API/blob/master/Features/exacte_match.feature).\&quot;
    # @option opts [String] :woonplaats_naam Naam van een woonplaats.
    # @option opts [String] :openbare_ruimte_naam Naam van een openbare ruimte.
    # @option opts [String] :openbare_ruimte_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @option opts [Boolean] :huidig Indicatie dat alleen actuele object voorkomens zonder eindstatus gewenst zijn.
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39;  Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Integer] :page Pagina nummer
    # @option opts [Integer] :page_size Aantal resultaten per pagina
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @option opts [String] :pand_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @return [Array<(NummeraanduidingIOHalCollection, Integer, Hash)>] NummeraanduidingIOHalCollection data, response status code and response headers
    def zoek_nummeraanduiding_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: NummeraanduidingApi.zoek_nummeraanduiding ...'
      end
      pattern = Regexp.new(/^[1-9]{1}[0-9]{3}[ ]{0,1}[a-zA-Z]{2}$/)
      if @api_client.config.client_side_validation && !opts[:'postcode'].nil? && opts[:'postcode'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"postcode\"]' when calling NummeraanduidingApi.zoek_nummeraanduiding, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'huisnummer'].nil? && opts[:'huisnummer'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"huisnummer"]" when calling NummeraanduidingApi.zoek_nummeraanduiding, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'huisnummer'].nil? && opts[:'huisnummer'] < 1
        fail ArgumentError, 'invalid value for "opts[:"huisnummer"]" when calling NummeraanduidingApi.zoek_nummeraanduiding, must be greater than or equal to 1.'
      end

      pattern = Regexp.new(/^[0-9a-zA-Z]{1,4}$/)
      if @api_client.config.client_side_validation && !opts[:'huisnummertoevoeging'].nil? && opts[:'huisnummertoevoeging'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"huisnummertoevoeging\"]' when calling NummeraanduidingApi.zoek_nummeraanduiding, must conform to the pattern #{pattern}."
      end

      pattern = Regexp.new(/^[a-zA-Z]{1}$/)
      if @api_client.config.client_side_validation && !opts[:'huisletter'].nil? && opts[:'huisletter'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"huisletter\"]' when calling NummeraanduidingApi.zoek_nummeraanduiding, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'woonplaats_naam'].nil? && opts[:'woonplaats_naam'].to_s.length > 80
        fail ArgumentError, 'invalid value for "opts[:"woonplaats_naam"]" when calling NummeraanduidingApi.zoek_nummeraanduiding, the character length must be smaller than or equal to 80.'
      end

      if @api_client.config.client_side_validation && !opts[:'woonplaats_naam'].nil? && opts[:'woonplaats_naam'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"woonplaats_naam"]" when calling NummeraanduidingApi.zoek_nummeraanduiding, the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if @api_client.config.client_side_validation && !opts[:'woonplaats_naam'].nil? && opts[:'woonplaats_naam'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"woonplaats_naam\"]' when calling NummeraanduidingApi.zoek_nummeraanduiding, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'openbare_ruimte_naam'].nil? && opts[:'openbare_ruimte_naam'].to_s.length > 80
        fail ArgumentError, 'invalid value for "opts[:"openbare_ruimte_naam"]" when calling NummeraanduidingApi.zoek_nummeraanduiding, the character length must be smaller than or equal to 80.'
      end

      if @api_client.config.client_side_validation && !opts[:'openbare_ruimte_naam'].nil? && opts[:'openbare_ruimte_naam'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"openbare_ruimte_naam"]" when calling NummeraanduidingApi.zoek_nummeraanduiding, the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if @api_client.config.client_side_validation && !opts[:'openbare_ruimte_naam'].nil? && opts[:'openbare_ruimte_naam'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"openbare_ruimte_naam\"]' when calling NummeraanduidingApi.zoek_nummeraanduiding, must conform to the pattern #{pattern}."
      end

      pattern = Regexp.new(/^[0-9]{4}30[0-9]{10}$/)
      if @api_client.config.client_side_validation && !opts[:'openbare_ruimte_identificatie'].nil? && opts[:'openbare_ruimte_identificatie'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"openbare_ruimte_identificatie\"]' when calling NummeraanduidingApi.zoek_nummeraanduiding, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'page'].nil? && opts[:'page'] < 1
        fail ArgumentError, 'invalid value for "opts[:"page"]" when calling NummeraanduidingApi.zoek_nummeraanduiding, must be greater than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 100
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling NummeraanduidingApi.zoek_nummeraanduiding, must be smaller than or equal to 100.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 10
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling NummeraanduidingApi.zoek_nummeraanduiding, must be greater than or equal to 10.'
      end

      pattern = Regexp.new(/^[0-9]{4}10[0-9]{10}$/)
      if @api_client.config.client_side_validation && !opts[:'pand_identificatie'].nil? && opts[:'pand_identificatie'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"pand_identificatie\"]' when calling NummeraanduidingApi.zoek_nummeraanduiding, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/nummeraanduidingen'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'postcode'] = opts[:'postcode'] if !opts[:'postcode'].nil?
      query_params[:'huisnummer'] = opts[:'huisnummer'] if !opts[:'huisnummer'].nil?
      query_params[:'huisnummertoevoeging'] = opts[:'huisnummertoevoeging'] if !opts[:'huisnummertoevoeging'].nil?
      query_params[:'huisletter'] = opts[:'huisletter'] if !opts[:'huisletter'].nil?
      query_params[:'exacteMatch'] = opts[:'exacte_match'] if !opts[:'exacte_match'].nil?
      query_params[:'woonplaatsNaam'] = opts[:'woonplaats_naam'] if !opts[:'woonplaats_naam'].nil?
      query_params[:'openbareRuimteNaam'] = opts[:'openbare_ruimte_naam'] if !opts[:'openbare_ruimte_naam'].nil?
      query_params[:'openbareRuimteIdentificatie'] = opts[:'openbare_ruimte_identificatie'] if !opts[:'openbare_ruimte_identificatie'].nil?
      query_params[:'huidig'] = opts[:'huidig'] if !opts[:'huidig'].nil?
      query_params[:'geldigOp'] = opts[:'geldig_op'] if !opts[:'geldig_op'].nil?
      query_params[:'beschikbaarOp'] = opts[:'beschikbaar_op'] if !opts[:'beschikbaar_op'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'expand'] = opts[:'expand'] if !opts[:'expand'].nil?
      query_params[:'pandIdentificatie'] = opts[:'pand_identificatie'] if !opts[:'pand_identificatie'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'NummeraanduidingIOHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"NummeraanduidingApi.zoek_nummeraanduiding",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: NummeraanduidingApi#zoek_nummeraanduiding\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
