=begin
#IMBAG API - van de LVBAG

#Dit is de [BAG API](https://zakelijk.kadaster.nl/-/bag-api) Individuele Bevragingen van de Landelijke Voorziening Basisregistratie Adressen en Gebouwen (LVBAG).                                         <br/>                                         Meer informatie over de Basisregistratie Adressen en Gebouwen is te vinden op de website van het [Ministerie van Binnenlandse Zaken en Koninkrijksrelaties](https://www.geobasisregistraties.nl/basisregistraties/adressen-en-gebouwen) en [Kadaster](https://zakelijk.kadaster.nl/bag).                                         <br/>                                         <br/>                                         De BAG API levert informatie conform de [BAG Catalogus 2018](https://www.geobasisregistraties.nl/documenten/publicatie/2018/03/12/catalogus-2018) en het informatiemodel IMBAG 2.0.                                         De API specificatie volgt de [Nederlandse API-Strategie](https://docs.geostandaarden.nl/api/API-Strategie) specificatie versie van 20200204 en is opgesteld in [OpenAPI Specificatie](https://www.forumstandaardisatie.nl/standaard/openapi-specification) (OAS) v3.                                         <br/>                                         Het standaard mediatype HAL (`application/hal+json`) wordt gebruikt. Dit is een mediatype voor het weergeven van resources en hun relaties via hyperlinks.                                         <br/>                                         <br/>                                         Deze API is vooral gericht op individuele bevragingen (op basis van de identificerende gegevens van een object).                                         Om gebruik te kunnen maken van de BAG API is een API key nodig, deze kan verkregen worden door het [aanvraagformulier](https://formulieren.kadaster.nl/aanvraag_bag_api_individuele_bevragingen_productie) in te vullen.                                         <br/>                                         <br/>                                         Voor vragen, neem contact op met de LVBAG beheerder o.v.v. BAG API 2.0. We zijn aan het kijken naar een geschikt medium hiervoor, mede ook om de API iteratief te kunnen opstellen of doorontwikkelen samen met de community. Als de API iets (nog) niet kan, wat u wel graag wilt, neem dan contact op.

The version of the OpenAPI document: 2.1.6

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.4.0-SNAPSHOT

=end

require 'cgi'

module BagKadasterClient
  class OpenbareRuimteApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # bevragen van een openbare ruimte met de identificatie van een openbare ruimte.
    # Bevragen/raadplegen van een openbare ruimte met de identificatie van een openbare ruimte. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.  Als expand=ligtInWoonplaats of true dan wordt de woonplaats als geneste resource geleverd.
    # @param openbare_ruimte_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39;  Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @return [OpenbareRuimteIOHal]
    def openbareruimte_identificatie(openbare_ruimte_identificatie, opts = {})
      data, _status_code, _headers = openbareruimte_identificatie_with_http_info(openbare_ruimte_identificatie, opts)
      data
    end

    # bevragen van een openbare ruimte met de identificatie van een openbare ruimte.
    # Bevragen/raadplegen van een openbare ruimte met de identificatie van een openbare ruimte. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.  Als expand&#x3D;ligtInWoonplaats of true dan wordt de woonplaats als geneste resource geleverd.
    # @param openbare_ruimte_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39;  Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @return [Array<(OpenbareRuimteIOHal, Integer, Hash)>] OpenbareRuimteIOHal data, response status code and response headers
    def openbareruimte_identificatie_with_http_info(openbare_ruimte_identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OpenbareRuimteApi.openbareruimte_identificatie ...'
      end
      # verify the required parameter 'openbare_ruimte_identificatie' is set
      if @api_client.config.client_side_validation && openbare_ruimte_identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'openbare_ruimte_identificatie' when calling OpenbareRuimteApi.openbareruimte_identificatie"
      end
      pattern = Regexp.new(/^[0-9]{4}30[0-9]{10}$/)
      if @api_client.config.client_side_validation && openbare_ruimte_identificatie !~ pattern
        fail ArgumentError, "invalid value for 'openbare_ruimte_identificatie' when calling OpenbareRuimteApi.openbareruimte_identificatie, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/openbareruimten/{openbareRuimteIdentificatie}'.sub('{' + 'openbareRuimteIdentificatie' + '}', CGI.escape(openbare_ruimte_identificatie.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'geldigOp'] = opts[:'geldig_op'] if !opts[:'geldig_op'].nil?
      query_params[:'beschikbaarOp'] = opts[:'beschikbaar_op'] if !opts[:'beschikbaar_op'].nil?
      query_params[:'expand'] = opts[:'expand'] if !opts[:'expand'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'OpenbareRuimteIOHal'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"OpenbareRuimteApi.openbareruimte_identificatie",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OpenbareRuimteApi#openbareruimte_identificatie\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen van een voorkomen van een openbare ruimte met de identificatie van een openbare ruimte en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # Bevragen/raadplegen van een voorkomen van een openbare ruimte met de identificatie van een openbare ruimte en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # @param openbare_ruimte_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param versie [Integer] De versie van een voorkomen van een object
    # @param timestamp_registratie_lv [String] Een timestamp van het tijdstip waarop een voorkomen is geregistreerd in de LV BAG
    # @param [Hash] opts the optional parameters
    # @return [OpenbareRuimteIOHal]
    def openbareruimte_identificatie_voorkomen(openbare_ruimte_identificatie, versie, timestamp_registratie_lv, opts = {})
      data, _status_code, _headers = openbareruimte_identificatie_voorkomen_with_http_info(openbare_ruimte_identificatie, versie, timestamp_registratie_lv, opts)
      data
    end

    # bevragen van een voorkomen van een openbare ruimte met de identificatie van een openbare ruimte en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # Bevragen/raadplegen van een voorkomen van een openbare ruimte met de identificatie van een openbare ruimte en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # @param openbare_ruimte_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param versie [Integer] De versie van een voorkomen van een object
    # @param timestamp_registratie_lv [String] Een timestamp van het tijdstip waarop een voorkomen is geregistreerd in de LV BAG
    # @param [Hash] opts the optional parameters
    # @return [Array<(OpenbareRuimteIOHal, Integer, Hash)>] OpenbareRuimteIOHal data, response status code and response headers
    def openbareruimte_identificatie_voorkomen_with_http_info(openbare_ruimte_identificatie, versie, timestamp_registratie_lv, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OpenbareRuimteApi.openbareruimte_identificatie_voorkomen ...'
      end
      # verify the required parameter 'openbare_ruimte_identificatie' is set
      if @api_client.config.client_side_validation && openbare_ruimte_identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'openbare_ruimte_identificatie' when calling OpenbareRuimteApi.openbareruimte_identificatie_voorkomen"
      end
      pattern = Regexp.new(/^[0-9]{4}30[0-9]{10}$/)
      if @api_client.config.client_side_validation && openbare_ruimte_identificatie !~ pattern
        fail ArgumentError, "invalid value for 'openbare_ruimte_identificatie' when calling OpenbareRuimteApi.openbareruimte_identificatie_voorkomen, must conform to the pattern #{pattern}."
      end

      # verify the required parameter 'versie' is set
      if @api_client.config.client_side_validation && versie.nil?
        fail ArgumentError, "Missing the required parameter 'versie' when calling OpenbareRuimteApi.openbareruimte_identificatie_voorkomen"
      end
      # verify the required parameter 'timestamp_registratie_lv' is set
      if @api_client.config.client_side_validation && timestamp_registratie_lv.nil?
        fail ArgumentError, "Missing the required parameter 'timestamp_registratie_lv' when calling OpenbareRuimteApi.openbareruimte_identificatie_voorkomen"
      end
      pattern = Regexp.new(/^\d+$/)
      if @api_client.config.client_side_validation && timestamp_registratie_lv !~ pattern
        fail ArgumentError, "invalid value for 'timestamp_registratie_lv' when calling OpenbareRuimteApi.openbareruimte_identificatie_voorkomen, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/openbareruimten/{openbareRuimteIdentificatie}/{versie}/{timestampRegistratieLv}'.sub('{' + 'openbareRuimteIdentificatie' + '}', CGI.escape(openbare_ruimte_identificatie.to_s)).sub('{' + 'versie' + '}', CGI.escape(versie.to_s)).sub('{' + 'timestampRegistratieLv' + '}', CGI.escape(timestamp_registratie_lv.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'OpenbareRuimteIOHal'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"OpenbareRuimteApi.openbareruimte_identificatie_voorkomen",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OpenbareRuimteApi#openbareruimte_identificatie_voorkomen\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen levenscyclus van een openbare ruimte met de identificatie van een openbare ruimte.
    # Bevragen/raadplegen van de levenscyclus van één openbare ruimte, via de identificatie van een openbare ruimte.
    # @param openbare_ruimte_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :gehele_lvc Filtert naast geldige voorkomens ook de voorkomens die uit de geldige levenscyclus van het object zijn verwijderd. Als deze parameter wordt weggelaten worden alleen geldige voorkomens geretourneerd (default is false). Voor een toelichting zie de [Praktijkhandleiding BAG](https://imbag.github.io/praktijkhandleiding/artikelen/wat-is-het-verschil-tussen-actieve-voorkomens-actuele-voorkomens-en-huidige-voorkomens). (default to false)
    # @return [OpenbareRuimteIOLvcHalCollection]
    def openbareruimte_lvc_identificatie(openbare_ruimte_identificatie, opts = {})
      data, _status_code, _headers = openbareruimte_lvc_identificatie_with_http_info(openbare_ruimte_identificatie, opts)
      data
    end

    # bevragen levenscyclus van een openbare ruimte met de identificatie van een openbare ruimte.
    # Bevragen/raadplegen van de levenscyclus van één openbare ruimte, via de identificatie van een openbare ruimte.
    # @param openbare_ruimte_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :gehele_lvc Filtert naast geldige voorkomens ook de voorkomens die uit de geldige levenscyclus van het object zijn verwijderd. Als deze parameter wordt weggelaten worden alleen geldige voorkomens geretourneerd (default is false). Voor een toelichting zie de [Praktijkhandleiding BAG](https://imbag.github.io/praktijkhandleiding/artikelen/wat-is-het-verschil-tussen-actieve-voorkomens-actuele-voorkomens-en-huidige-voorkomens).
    # @return [Array<(OpenbareRuimteIOLvcHalCollection, Integer, Hash)>] OpenbareRuimteIOLvcHalCollection data, response status code and response headers
    def openbareruimte_lvc_identificatie_with_http_info(openbare_ruimte_identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OpenbareRuimteApi.openbareruimte_lvc_identificatie ...'
      end
      # verify the required parameter 'openbare_ruimte_identificatie' is set
      if @api_client.config.client_side_validation && openbare_ruimte_identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'openbare_ruimte_identificatie' when calling OpenbareRuimteApi.openbareruimte_lvc_identificatie"
      end
      pattern = Regexp.new(/^[0-9]{4}30[0-9]{10}$/)
      if @api_client.config.client_side_validation && openbare_ruimte_identificatie !~ pattern
        fail ArgumentError, "invalid value for 'openbare_ruimte_identificatie' when calling OpenbareRuimteApi.openbareruimte_lvc_identificatie, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/openbareruimten/{openbareRuimteIdentificatie}/lvc'.sub('{' + 'openbareRuimteIdentificatie' + '}', CGI.escape(openbare_ruimte_identificatie.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'geheleLvc'] = opts[:'gehele_lvc'] if !opts[:'gehele_lvc'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'OpenbareRuimteIOLvcHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"OpenbareRuimteApi.openbareruimte_lvc_identificatie",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OpenbareRuimteApi#openbareruimte_lvc_identificatie\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen openbare ruimte(n) op basis van de verschillende combinaties van parameters.
    # De volgende (combinaties van) parameters worden ondersteund:<br/> <ol>   <li>     Bevragen/raadplegen van een openbare ruimte met een woonplaats naam en een openbare ruimte naam.     Als expand=ligtInWoonplaats of true dan wordt de woonplaats als geneste resource geleverd.   </li>   <li>     Bevragen/raadplegen van een openbare ruimte met een woonplaats identificatie en een openbare ruimte naam.     Als expand=ligtInWoonplaats of true dan wordt de woonplaats als geneste resource geleverd.   </li>   <li>     Bevragen/zoeken van alle aan een woonplaats gerelateerde openbare ruimten met de woonplaats identificatie.     Parameter huidig kan worden toegepast.     Expand wordt niet ondersteund.   </li> </ol> Bij alle bovenstaande combinaties wordt paginering ondersteund en kunnen de parameters geldigOp en beschikbaarOp worden gebruikt. Voor paginering, zie: [functionele specificatie paginering](https://github.com/lvbag/BAG-API/blob/master/Features/paginering.feature). Als geldigOp en beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :woonplaats_naam Naam van een woonplaats object uit de BAG.
    # @option opts [String] :openbare_ruimte_naam Naam van een openbare ruimte object uit de BAG.
    # @option opts [String] :woonplaats_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @option opts [Boolean] :huidig Indicatie dat alleen actuele object voorkomens zonder eindstatus gewenst zijn. (default to false)
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39;  Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Integer] :page Pagina nummer (default to 1)
    # @option opts [Integer] :page_size Aantal resultaten per pagina (default to 20)
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @return [OpenbareRuimteIOHalCollection]
    def zoek_openbare_ruimten(opts = {})
      data, _status_code, _headers = zoek_openbare_ruimten_with_http_info(opts)
      data
    end

    # bevragen openbare ruimte(n) op basis van de verschillende combinaties van parameters.
    # De volgende (combinaties van) parameters worden ondersteund:&lt;br/&gt; &lt;ol&gt;   &lt;li&gt;     Bevragen/raadplegen van een openbare ruimte met een woonplaats naam en een openbare ruimte naam.     Als expand&#x3D;ligtInWoonplaats of true dan wordt de woonplaats als geneste resource geleverd.   &lt;/li&gt;   &lt;li&gt;     Bevragen/raadplegen van een openbare ruimte met een woonplaats identificatie en een openbare ruimte naam.     Als expand&#x3D;ligtInWoonplaats of true dan wordt de woonplaats als geneste resource geleverd.   &lt;/li&gt;   &lt;li&gt;     Bevragen/zoeken van alle aan een woonplaats gerelateerde openbare ruimten met de woonplaats identificatie.     Parameter huidig kan worden toegepast.     Expand wordt niet ondersteund.   &lt;/li&gt; &lt;/ol&gt; Bij alle bovenstaande combinaties wordt paginering ondersteund en kunnen de parameters geldigOp en beschikbaarOp worden gebruikt. Voor paginering, zie: [functionele specificatie paginering](https://github.com/lvbag/BAG-API/blob/master/Features/paginering.feature). Als geldigOp en beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :woonplaats_naam Naam van een woonplaats object uit de BAG.
    # @option opts [String] :openbare_ruimte_naam Naam van een openbare ruimte object uit de BAG.
    # @option opts [String] :woonplaats_identificatie Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @option opts [Boolean] :huidig Indicatie dat alleen actuele object voorkomens zonder eindstatus gewenst zijn.
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#39;YYYY-MM-DD&#39;  Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Integer] :page Pagina nummer
    # @option opts [Integer] :page_size Aantal resultaten per pagina
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @return [Array<(OpenbareRuimteIOHalCollection, Integer, Hash)>] OpenbareRuimteIOHalCollection data, response status code and response headers
    def zoek_openbare_ruimten_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OpenbareRuimteApi.zoek_openbare_ruimten ...'
      end
      if @api_client.config.client_side_validation && !opts[:'woonplaats_naam'].nil? && opts[:'woonplaats_naam'].to_s.length > 80
        fail ArgumentError, 'invalid value for "opts[:"woonplaats_naam"]" when calling OpenbareRuimteApi.zoek_openbare_ruimten, the character length must be smaller than or equal to 80.'
      end

      if @api_client.config.client_side_validation && !opts[:'woonplaats_naam'].nil? && opts[:'woonplaats_naam'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"woonplaats_naam"]" when calling OpenbareRuimteApi.zoek_openbare_ruimten, the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if @api_client.config.client_side_validation && !opts[:'woonplaats_naam'].nil? && opts[:'woonplaats_naam'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"woonplaats_naam\"]' when calling OpenbareRuimteApi.zoek_openbare_ruimten, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'openbare_ruimte_naam'].nil? && opts[:'openbare_ruimte_naam'].to_s.length > 80
        fail ArgumentError, 'invalid value for "opts[:"openbare_ruimte_naam"]" when calling OpenbareRuimteApi.zoek_openbare_ruimten, the character length must be smaller than or equal to 80.'
      end

      if @api_client.config.client_side_validation && !opts[:'openbare_ruimte_naam'].nil? && opts[:'openbare_ruimte_naam'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"openbare_ruimte_naam"]" when calling OpenbareRuimteApi.zoek_openbare_ruimten, the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if @api_client.config.client_side_validation && !opts[:'openbare_ruimte_naam'].nil? && opts[:'openbare_ruimte_naam'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"openbare_ruimte_naam\"]' when calling OpenbareRuimteApi.zoek_openbare_ruimten, must conform to the pattern #{pattern}."
      end

      pattern = Regexp.new(/[0-9]{3}[1-9]|[0-9]{2}[1-9][0-9]|[0-9][1-9][0-9]{2}|[1-9][0-9]{3}/)
      if @api_client.config.client_side_validation && !opts[:'woonplaats_identificatie'].nil? && opts[:'woonplaats_identificatie'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"woonplaats_identificatie\"]' when calling OpenbareRuimteApi.zoek_openbare_ruimten, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'page'].nil? && opts[:'page'] < 1
        fail ArgumentError, 'invalid value for "opts[:"page"]" when calling OpenbareRuimteApi.zoek_openbare_ruimten, must be greater than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 100
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling OpenbareRuimteApi.zoek_openbare_ruimten, must be smaller than or equal to 100.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 10
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling OpenbareRuimteApi.zoek_openbare_ruimten, must be greater than or equal to 10.'
      end

      # resource path
      local_var_path = '/openbareruimten'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'woonplaatsNaam'] = opts[:'woonplaats_naam'] if !opts[:'woonplaats_naam'].nil?
      query_params[:'openbareRuimteNaam'] = opts[:'openbare_ruimte_naam'] if !opts[:'openbare_ruimte_naam'].nil?
      query_params[:'woonplaatsIdentificatie'] = opts[:'woonplaats_identificatie'] if !opts[:'woonplaats_identificatie'].nil?
      query_params[:'huidig'] = opts[:'huidig'] if !opts[:'huidig'].nil?
      query_params[:'geldigOp'] = opts[:'geldig_op'] if !opts[:'geldig_op'].nil?
      query_params[:'beschikbaarOp'] = opts[:'beschikbaar_op'] if !opts[:'beschikbaar_op'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'expand'] = opts[:'expand'] if !opts[:'expand'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'OpenbareRuimteIOHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"OpenbareRuimteApi.zoek_openbare_ruimten",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OpenbareRuimteApi#zoek_openbare_ruimten\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
