=begin
#IMBAG API - van de LVBAG

#Dit is de [BAG API](https://zakelijk.kadaster.nl/-/bag-api) Individuele Bevragingen van de Landelijke Voorziening Basisregistratie Adressen en Gebouwen (LVBAG).                                         <br/>                                         Meer informatie over de Basisregistratie Adressen en Gebouwen is te vinden op de website van het [Ministerie van Binnenlandse Zaken en Koninkrijksrelaties](https://www.geobasisregistraties.nl/basisregistraties/adressen-en-gebouwen) en [Kadaster](https://zakelijk.kadaster.nl/bag).                                         <br/>                                         <br/>                                         De BAG API levert informatie conform de [BAG Catalogus 2018](https://www.geobasisregistraties.nl/documenten/publicatie/2018/03/12/catalogus-2018) en het informatiemodel IMBAG 2.0.                                         De API specificatie volgt de [Nederlandse API-Strategie](https://docs.geostandaarden.nl/api/API-Strategie) specificatie versie van 20200204 en is opgesteld in [OpenAPI Specificatie](https://www.forumstandaardisatie.nl/standaard/openapi-specification) (OAS) v3.                                         <br/>                                         Het standaard mediatype HAL (`application/hal+json`) wordt gebruikt. Dit is een mediatype voor het weergeven van resources en hun relaties via hyperlinks.                                         <br/>                                         <br/>                                         Deze API is vooral gericht op individuele bevragingen (op basis van de identificerende gegevens van een object).                                         Om gebruik te kunnen maken van de BAG API is een API key nodig, deze kan verkregen worden door het [aanvraagformulier](https://formulieren.kadaster.nl/aanvraag_bag_api_individuele_bevragingen_productie) in te vullen.                                         <br/>                                         <br/>                                         Voor vragen, neem contact op met de LVBAG beheerder o.v.v. BAG API 2.0. We zijn aan het kijken naar een geschikt medium hiervoor, mede ook om de API iteratief te kunnen opstellen of doorontwikkelen samen met de community. Als de API iets (nog) niet kan, wat u wel graag wilt, neem dan contact op.

The version of the OpenAPI document: 2.1.6

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.4.0-SNAPSHOT

=end

require 'cgi'

module BagKadasterClient
  class PandApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # bevragen panden met een geometrische locatie.
    # Bevragen/raadplegen van een voorkomen van één of meer panden met de geometrische locatie van het pand. Parameter huidig kan worden toegepast. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.
    # @param point [Point] Geometrisch punt waarop de panden bepaald moeten worden.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#x60;JJJJ-MM-DD&#x60; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Boolean] :huidig Indicatie dat alleen actuele object voorkomens zonder eindstatus gewenst zijn. (default to false)
    # @option opts [String] :content_crs CRS van de meegegeven geometrie.
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [PandIOHalCollection]
    def pand_geometrie(point, opts = {})
      data, _status_code, _headers = pand_geometrie_with_http_info(point, opts)
      data
    end

    # bevragen panden met een geometrische locatie.
    # Bevragen/raadplegen van een voorkomen van één of meer panden met de geometrische locatie van het pand. Parameter huidig kan worden toegepast. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.
    # @param point [Point] Geometrisch punt waarop de panden bepaald moeten worden.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#x60;JJJJ-MM-DD&#x60; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Boolean] :huidig Indicatie dat alleen actuele object voorkomens zonder eindstatus gewenst zijn.
    # @option opts [String] :content_crs CRS van de meegegeven geometrie.
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [Array<(PandIOHalCollection, Integer, Hash)>] PandIOHalCollection data, response status code and response headers
    def pand_geometrie_with_http_info(point, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PandApi.pand_geometrie ...'
      end
      # verify the required parameter 'point' is set
      if @api_client.config.client_side_validation && point.nil?
        fail ArgumentError, "Missing the required parameter 'point' when calling PandApi.pand_geometrie"
      end
      allowable_values = ["epsg:28992"]
      if @api_client.config.client_side_validation && opts[:'content_crs'] && !allowable_values.include?(opts[:'content_crs'])
        fail ArgumentError, "invalid value for \"content_crs\", must be one of #{allowable_values}"
      end
      allowable_values = ["epsg:28992"]
      if @api_client.config.client_side_validation && opts[:'accept_crs'] && !allowable_values.include?(opts[:'accept_crs'])
        fail ArgumentError, "invalid value for \"accept_crs\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/panden'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'geldigOp'] = opts[:'geldig_op'] if !opts[:'geldig_op'].nil?
      query_params[:'beschikbaarOp'] = opts[:'beschikbaar_op'] if !opts[:'beschikbaar_op'].nil?
      query_params[:'huidig'] = opts[:'huidig'] if !opts[:'huidig'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end
      header_params[:'Content-Crs'] = opts[:'content_crs'] if !opts[:'content_crs'].nil?
      header_params[:'Accept-Crs'] = opts[:'accept_crs'] if !opts[:'accept_crs'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(point)

      # return_type
      return_type = opts[:debug_return_type] || 'PandIOHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"PandApi.pand_geometrie",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PandApi#pand_geometrie\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen van een pand met de identificatie van een pand.
    # Bevragen/raadplegen van een voorkomen van een pand met de identificatie van het pand. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.
    # @param identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#x60;JJJJ-MM-DD&#x60; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [PandIOHal]
    def pand_identificatie(identificatie, opts = {})
      data, _status_code, _headers = pand_identificatie_with_http_info(identificatie, opts)
      data
    end

    # bevragen van een pand met de identificatie van een pand.
    # Bevragen/raadplegen van een voorkomen van een pand met de identificatie van het pand. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd.
    # @param identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#x60;JJJJ-MM-DD&#x60; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [Array<(PandIOHal, Integer, Hash)>] PandIOHal data, response status code and response headers
    def pand_identificatie_with_http_info(identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PandApi.pand_identificatie ...'
      end
      # verify the required parameter 'identificatie' is set
      if @api_client.config.client_side_validation && identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'identificatie' when calling PandApi.pand_identificatie"
      end
      pattern = Regexp.new(/^[0-9]{4}10[0-9]{10}$/)
      if @api_client.config.client_side_validation && identificatie !~ pattern
        fail ArgumentError, "invalid value for 'identificatie' when calling PandApi.pand_identificatie, must conform to the pattern #{pattern}."
      end

      allowable_values = ["epsg:28992"]
      if @api_client.config.client_side_validation && opts[:'accept_crs'] && !allowable_values.include?(opts[:'accept_crs'])
        fail ArgumentError, "invalid value for \"accept_crs\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/panden/{identificatie}'.sub('{' + 'identificatie' + '}', CGI.escape(identificatie.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'geldigOp'] = opts[:'geldig_op'] if !opts[:'geldig_op'].nil?
      query_params[:'beschikbaarOp'] = opts[:'beschikbaar_op'] if !opts[:'beschikbaar_op'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])
      header_params[:'Accept-Crs'] = opts[:'accept_crs'] if !opts[:'accept_crs'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'PandIOHal'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"PandApi.pand_identificatie",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PandApi#pand_identificatie\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen voorkomen van een pand met de identificatie van een pand en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # Bevragen/raadplegen van een voorkomen van een pand met de identificatie van een pand en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # @param identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param versie [Integer] De versie van een voorkomen van een object
    # @param timestamp_registratie_lv [String] Een timestamp van het tijdstip waarop een voorkomen is geregistreerd in de LV BAG
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [PandIOHal]
    def pand_identificatie_voorkomen(identificatie, versie, timestamp_registratie_lv, opts = {})
      data, _status_code, _headers = pand_identificatie_voorkomen_with_http_info(identificatie, versie, timestamp_registratie_lv, opts)
      data
    end

    # bevragen voorkomen van een pand met de identificatie van een pand en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # Bevragen/raadplegen van een voorkomen van een pand met de identificatie van een pand en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # @param identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param versie [Integer] De versie van een voorkomen van een object
    # @param timestamp_registratie_lv [String] Een timestamp van het tijdstip waarop een voorkomen is geregistreerd in de LV BAG
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [Array<(PandIOHal, Integer, Hash)>] PandIOHal data, response status code and response headers
    def pand_identificatie_voorkomen_with_http_info(identificatie, versie, timestamp_registratie_lv, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PandApi.pand_identificatie_voorkomen ...'
      end
      # verify the required parameter 'identificatie' is set
      if @api_client.config.client_side_validation && identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'identificatie' when calling PandApi.pand_identificatie_voorkomen"
      end
      pattern = Regexp.new(/^[0-9]{4}10[0-9]{10}$/)
      if @api_client.config.client_side_validation && identificatie !~ pattern
        fail ArgumentError, "invalid value for 'identificatie' when calling PandApi.pand_identificatie_voorkomen, must conform to the pattern #{pattern}."
      end

      # verify the required parameter 'versie' is set
      if @api_client.config.client_side_validation && versie.nil?
        fail ArgumentError, "Missing the required parameter 'versie' when calling PandApi.pand_identificatie_voorkomen"
      end
      # verify the required parameter 'timestamp_registratie_lv' is set
      if @api_client.config.client_side_validation && timestamp_registratie_lv.nil?
        fail ArgumentError, "Missing the required parameter 'timestamp_registratie_lv' when calling PandApi.pand_identificatie_voorkomen"
      end
      pattern = Regexp.new(/^\d+$/)
      if @api_client.config.client_side_validation && timestamp_registratie_lv !~ pattern
        fail ArgumentError, "invalid value for 'timestamp_registratie_lv' when calling PandApi.pand_identificatie_voorkomen, must conform to the pattern #{pattern}."
      end

      allowable_values = ["epsg:28992"]
      if @api_client.config.client_side_validation && opts[:'accept_crs'] && !allowable_values.include?(opts[:'accept_crs'])
        fail ArgumentError, "invalid value for \"accept_crs\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/panden/{identificatie}/{versie}/{timestampRegistratieLv}'.sub('{' + 'identificatie' + '}', CGI.escape(identificatie.to_s)).sub('{' + 'versie' + '}', CGI.escape(versie.to_s)).sub('{' + 'timestampRegistratieLv' + '}', CGI.escape(timestamp_registratie_lv.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])
      header_params[:'Accept-Crs'] = opts[:'accept_crs'] if !opts[:'accept_crs'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'PandIOHal'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"PandApi.pand_identificatie_voorkomen",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PandApi#pand_identificatie_voorkomen\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen levenscyclus van een pand met de identificatie van een pand.
    # Bevragen/raadplegen van de levenscyclus van een pand met de identificatie van een pand.
    # @param identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :gehele_lvc Filtert naast geldige voorkomens ook de voorkomens die uit de geldige levenscyclus van het object zijn verwijderd. Als deze parameter wordt weggelaten worden alleen geldige voorkomens geretourneerd (default is false). Voor een toelichting zie de [Praktijkhandleiding BAG](https://imbag.github.io/praktijkhandleiding/artikelen/wat-is-het-verschil-tussen-actieve-voorkomens-actuele-voorkomens-en-huidige-voorkomens). (default to false)
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [PandIOLvcHalCollection]
    def pand_lvc_identificatie(identificatie, opts = {})
      data, _status_code, _headers = pand_lvc_identificatie_with_http_info(identificatie, opts)
      data
    end

    # bevragen levenscyclus van een pand met de identificatie van een pand.
    # Bevragen/raadplegen van de levenscyclus van een pand met de identificatie van een pand.
    # @param identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :gehele_lvc Filtert naast geldige voorkomens ook de voorkomens die uit de geldige levenscyclus van het object zijn verwijderd. Als deze parameter wordt weggelaten worden alleen geldige voorkomens geretourneerd (default is false). Voor een toelichting zie de [Praktijkhandleiding BAG](https://imbag.github.io/praktijkhandleiding/artikelen/wat-is-het-verschil-tussen-actieve-voorkomens-actuele-voorkomens-en-huidige-voorkomens).
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [Array<(PandIOLvcHalCollection, Integer, Hash)>] PandIOLvcHalCollection data, response status code and response headers
    def pand_lvc_identificatie_with_http_info(identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PandApi.pand_lvc_identificatie ...'
      end
      # verify the required parameter 'identificatie' is set
      if @api_client.config.client_side_validation && identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'identificatie' when calling PandApi.pand_lvc_identificatie"
      end
      pattern = Regexp.new(/^[0-9]{4}10[0-9]{10}$/)
      if @api_client.config.client_side_validation && identificatie !~ pattern
        fail ArgumentError, "invalid value for 'identificatie' when calling PandApi.pand_lvc_identificatie, must conform to the pattern #{pattern}."
      end

      allowable_values = ["epsg:28992"]
      if @api_client.config.client_side_validation && opts[:'accept_crs'] && !allowable_values.include?(opts[:'accept_crs'])
        fail ArgumentError, "invalid value for \"accept_crs\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/panden/{identificatie}/lvc'.sub('{' + 'identificatie' + '}', CGI.escape(identificatie.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'geheleLvc'] = opts[:'gehele_lvc'] if !opts[:'gehele_lvc'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])
      header_params[:'Accept-Crs'] = opts[:'accept_crs'] if !opts[:'accept_crs'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'PandIOLvcHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"PandApi.pand_lvc_identificatie",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PandApi#pand_lvc_identificatie\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
