=begin
#IMBAG API - van de LVBAG

#Dit is de [BAG API](https://zakelijk.kadaster.nl/-/bag-api) Individuele Bevragingen van de Landelijke Voorziening Basisregistratie Adressen en Gebouwen (LVBAG).                                         <br/>                                         Meer informatie over de Basisregistratie Adressen en Gebouwen is te vinden op de website van het [Ministerie van Binnenlandse Zaken en Koninkrijksrelaties](https://www.geobasisregistraties.nl/basisregistraties/adressen-en-gebouwen) en [Kadaster](https://zakelijk.kadaster.nl/bag).                                         <br/>                                         <br/>                                         De BAG API levert informatie conform de [BAG Catalogus 2018](https://www.geobasisregistraties.nl/documenten/publicatie/2018/03/12/catalogus-2018) en het informatiemodel IMBAG 2.0.                                         De API specificatie volgt de [Nederlandse API-Strategie](https://docs.geostandaarden.nl/api/API-Strategie) specificatie versie van 20200204 en is opgesteld in [OpenAPI Specificatie](https://www.forumstandaardisatie.nl/standaard/openapi-specification) (OAS) v3.                                         <br/>                                         Het standaard mediatype HAL (`application/hal+json`) wordt gebruikt. Dit is een mediatype voor het weergeven van resources en hun relaties via hyperlinks.                                         <br/>                                         <br/>                                         Deze API is vooral gericht op individuele bevragingen (op basis van de identificerende gegevens van een object).                                         Om gebruik te kunnen maken van de BAG API is een API key nodig, deze kan verkregen worden door het [aanvraagformulier](https://formulieren.kadaster.nl/aanvraag_bag_api_individuele_bevragingen_productie) in te vullen.                                         <br/>                                         <br/>                                         Voor vragen, neem contact op met de LVBAG beheerder o.v.v. BAG API 2.0. We zijn aan het kijken naar een geschikt medium hiervoor, mede ook om de API iteratief te kunnen opstellen of doorontwikkelen samen met de community. Als de API iets (nog) niet kan, wat u wel graag wilt, neem dan contact op.

The version of the OpenAPI document: 2.1.6

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.4.0-SNAPSHOT

=end

require 'cgi'

module BagKadasterClient
  class VerblijfsobjectApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # bevragen 1 verblijfsobject met de identificatie van een verblijfsobject.
    # Bevragen/raadplegen van één voorkomen van een Verblijfsobject met de identificatie van een verblijfsobject. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd. Als expand=heeftAlsHoofdAdres, heeftAlsNevenAdres, maaktDeelUitVan of true, dan worden de gevraagde of alle gerelateerde objecten als geneste resource geleverd.
    # @param identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#x60;JJJJ-MM-DD&#x60; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [VerblijfsobjectIOHal]
    def verblijfsobject_identificatie(identificatie, opts = {})
      data, _status_code, _headers = verblijfsobject_identificatie_with_http_info(identificatie, opts)
      data
    end

    # bevragen 1 verblijfsobject met de identificatie van een verblijfsobject.
    # Bevragen/raadplegen van één voorkomen van een Verblijfsobject met de identificatie van een verblijfsobject. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd. Als expand&#x3D;heeftAlsHoofdAdres, heeftAlsNevenAdres, maaktDeelUitVan of true, dan worden de gevraagde of alle gerelateerde objecten als geneste resource geleverd.
    # @param identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#x60;JJJJ-MM-DD&#x60; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [String] :expand Hier kan aangegeven worden welke gerelateerde resources meegeladen moeten worden. Resources en velden van resources die gewenst zijn kunnen in de expand parameter kommagescheiden worden opgegeven. Specifieke velden van resource kunnen worden opgegeven door het opgeven van de resource-naam gevolgd door de veldnaam, met daartussen een punt.
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [Array<(VerblijfsobjectIOHal, Integer, Hash)>] VerblijfsobjectIOHal data, response status code and response headers
    def verblijfsobject_identificatie_with_http_info(identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: VerblijfsobjectApi.verblijfsobject_identificatie ...'
      end
      # verify the required parameter 'identificatie' is set
      if @api_client.config.client_side_validation && identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'identificatie' when calling VerblijfsobjectApi.verblijfsobject_identificatie"
      end
      pattern = Regexp.new(/^[0-9]{4}01[0-9]{10}$/)
      if @api_client.config.client_side_validation && identificatie !~ pattern
        fail ArgumentError, "invalid value for 'identificatie' when calling VerblijfsobjectApi.verblijfsobject_identificatie, must conform to the pattern #{pattern}."
      end

      allowable_values = ["epsg:28992"]
      if @api_client.config.client_side_validation && opts[:'accept_crs'] && !allowable_values.include?(opts[:'accept_crs'])
        fail ArgumentError, "invalid value for \"accept_crs\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/verblijfsobjecten/{identificatie}'.sub('{' + 'identificatie' + '}', CGI.escape(identificatie.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'geldigOp'] = opts[:'geldig_op'] if !opts[:'geldig_op'].nil?
      query_params[:'beschikbaarOp'] = opts[:'beschikbaar_op'] if !opts[:'beschikbaar_op'].nil?
      query_params[:'expand'] = opts[:'expand'] if !opts[:'expand'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])
      header_params[:'Accept-Crs'] = opts[:'accept_crs'] if !opts[:'accept_crs'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'VerblijfsobjectIOHal'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"VerblijfsobjectApi.verblijfsobject_identificatie",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VerblijfsobjectApi#verblijfsobject_identificatie\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen voorkomen van een verblijfsobject, op basis van de identificatie van een verblijfsobject en de identificatie van een voorkomen
    # Bevragen/raadplegen van een voorkomen van een verblijfsobject, met de identificatie van een verblijfsobject en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # @param identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param versie [Integer] De versie van een voorkomen van een object
    # @param timestamp_registratie_lv [String] Een timestamp van het tijdstip waarop een voorkomen is geregistreerd in de LV BAG
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [VerblijfsobjectIOHal]
    def verblijfsobject_identificatie_voorkomen(identificatie, versie, timestamp_registratie_lv, opts = {})
      data, _status_code, _headers = verblijfsobject_identificatie_voorkomen_with_http_info(identificatie, versie, timestamp_registratie_lv, opts)
      data
    end

    # bevragen voorkomen van een verblijfsobject, op basis van de identificatie van een verblijfsobject en de identificatie van een voorkomen
    # Bevragen/raadplegen van een voorkomen van een verblijfsobject, met de identificatie van een verblijfsobject en de identificatie van een voorkomen, bestaande uit een versie en een timestamp van het tijdstip van registratie in de LV BAG.
    # @param identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param versie [Integer] De versie van een voorkomen van een object
    # @param timestamp_registratie_lv [String] Een timestamp van het tijdstip waarop een voorkomen is geregistreerd in de LV BAG
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [Array<(VerblijfsobjectIOHal, Integer, Hash)>] VerblijfsobjectIOHal data, response status code and response headers
    def verblijfsobject_identificatie_voorkomen_with_http_info(identificatie, versie, timestamp_registratie_lv, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: VerblijfsobjectApi.verblijfsobject_identificatie_voorkomen ...'
      end
      # verify the required parameter 'identificatie' is set
      if @api_client.config.client_side_validation && identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'identificatie' when calling VerblijfsobjectApi.verblijfsobject_identificatie_voorkomen"
      end
      pattern = Regexp.new(/^[0-9]{4}01[0-9]{10}$/)
      if @api_client.config.client_side_validation && identificatie !~ pattern
        fail ArgumentError, "invalid value for 'identificatie' when calling VerblijfsobjectApi.verblijfsobject_identificatie_voorkomen, must conform to the pattern #{pattern}."
      end

      # verify the required parameter 'versie' is set
      if @api_client.config.client_side_validation && versie.nil?
        fail ArgumentError, "Missing the required parameter 'versie' when calling VerblijfsobjectApi.verblijfsobject_identificatie_voorkomen"
      end
      # verify the required parameter 'timestamp_registratie_lv' is set
      if @api_client.config.client_side_validation && timestamp_registratie_lv.nil?
        fail ArgumentError, "Missing the required parameter 'timestamp_registratie_lv' when calling VerblijfsobjectApi.verblijfsobject_identificatie_voorkomen"
      end
      pattern = Regexp.new(/^\d+$/)
      if @api_client.config.client_side_validation && timestamp_registratie_lv !~ pattern
        fail ArgumentError, "invalid value for 'timestamp_registratie_lv' when calling VerblijfsobjectApi.verblijfsobject_identificatie_voorkomen, must conform to the pattern #{pattern}."
      end

      allowable_values = ["epsg:28992"]
      if @api_client.config.client_side_validation && opts[:'accept_crs'] && !allowable_values.include?(opts[:'accept_crs'])
        fail ArgumentError, "invalid value for \"accept_crs\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/verblijfsobjecten/{identificatie}/{versie}/{timestampRegistratieLv}'.sub('{' + 'identificatie' + '}', CGI.escape(identificatie.to_s)).sub('{' + 'versie' + '}', CGI.escape(versie.to_s)).sub('{' + 'timestampRegistratieLv' + '}', CGI.escape(timestamp_registratie_lv.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])
      header_params[:'Accept-Crs'] = opts[:'accept_crs'] if !opts[:'accept_crs'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'VerblijfsobjectIOHal'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"VerblijfsobjectApi.verblijfsobject_identificatie_voorkomen",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VerblijfsobjectApi#verblijfsobject_identificatie_voorkomen\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen levenscyclus van een verblijfsobject met de identificatie van een verblijfsobject.
    # Bevragen/raadplegen van de levenscyclus van een Verblijfsobject met de identificatie van de verblijfsobject.
    # @param identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :gehele_lvc Filtert naast geldige voorkomens ook de voorkomens die uit de geldige levenscyclus van het object zijn verwijderd. Als deze parameter wordt weggelaten worden alleen geldige voorkomens geretourneerd (default is false). Voor een toelichting zie de [Praktijkhandleiding BAG](https://imbag.github.io/praktijkhandleiding/artikelen/wat-is-het-verschil-tussen-actieve-voorkomens-actuele-voorkomens-en-huidige-voorkomens). (default to false)
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [VerblijfsobjectIOLvcHalCollection]
    def verblijfsobject_lvc_identificatie(identificatie, opts = {})
      data, _status_code, _headers = verblijfsobject_lvc_identificatie_with_http_info(identificatie, opts)
      data
    end

    # bevragen levenscyclus van een verblijfsobject met de identificatie van een verblijfsobject.
    # Bevragen/raadplegen van de levenscyclus van een Verblijfsobject met de identificatie van de verblijfsobject.
    # @param identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :gehele_lvc Filtert naast geldige voorkomens ook de voorkomens die uit de geldige levenscyclus van het object zijn verwijderd. Als deze parameter wordt weggelaten worden alleen geldige voorkomens geretourneerd (default is false). Voor een toelichting zie de [Praktijkhandleiding BAG](https://imbag.github.io/praktijkhandleiding/artikelen/wat-is-het-verschil-tussen-actieve-voorkomens-actuele-voorkomens-en-huidige-voorkomens).
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [Array<(VerblijfsobjectIOLvcHalCollection, Integer, Hash)>] VerblijfsobjectIOLvcHalCollection data, response status code and response headers
    def verblijfsobject_lvc_identificatie_with_http_info(identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: VerblijfsobjectApi.verblijfsobject_lvc_identificatie ...'
      end
      # verify the required parameter 'identificatie' is set
      if @api_client.config.client_side_validation && identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'identificatie' when calling VerblijfsobjectApi.verblijfsobject_lvc_identificatie"
      end
      pattern = Regexp.new(/^[0-9]{4}01[0-9]{10}$/)
      if @api_client.config.client_side_validation && identificatie !~ pattern
        fail ArgumentError, "invalid value for 'identificatie' when calling VerblijfsobjectApi.verblijfsobject_lvc_identificatie, must conform to the pattern #{pattern}."
      end

      allowable_values = ["epsg:28992"]
      if @api_client.config.client_side_validation && opts[:'accept_crs'] && !allowable_values.include?(opts[:'accept_crs'])
        fail ArgumentError, "invalid value for \"accept_crs\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/verblijfsobjecten/{identificatie}/lvc'.sub('{' + 'identificatie' + '}', CGI.escape(identificatie.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'geheleLvc'] = opts[:'gehele_lvc'] if !opts[:'gehele_lvc'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])
      header_params[:'Accept-Crs'] = opts[:'accept_crs'] if !opts[:'accept_crs'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'VerblijfsobjectIOLvcHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"VerblijfsobjectApi.verblijfsobject_lvc_identificatie",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VerblijfsobjectApi#verblijfsobject_lvc_identificatie\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # bevragen van alle aan een pand gerelateerde verblijfsobjecten (met paginering).
    # Bevragen/zoeken van alle aan een pand gerelateerde verblijfsobjecten, met een pand identificatie en met paginering. Parameter huidig kan worden toegepast. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd. Voor paginering, zie: [functionele specificatie paginering](https://github.com/lvbag/BAG-API/blob/master/Features/paginering.feature).
    # @param pand_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :huidig Indicatie dat alleen actuele object voorkomens zonder eindstatus gewenst zijn. (default to false)
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#x60;JJJJ-MM-DD&#x60; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Integer] :page Pagina nummer (default to 1)
    # @option opts [Integer] :page_size Aantal resultaten per pagina (default to 20)
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [VerblijfsobjectIOHalCollection]
    def zoek_verblijfsobjecten(pand_identificatie, opts = {})
      data, _status_code, _headers = zoek_verblijfsobjecten_with_http_info(pand_identificatie, opts)
      data
    end

    # bevragen van alle aan een pand gerelateerde verblijfsobjecten (met paginering).
    # Bevragen/zoeken van alle aan een pand gerelateerde verblijfsobjecten, met een pand identificatie en met paginering. Parameter huidig kan worden toegepast. Als geldigOp en/of beschikbaarOp niet wordt opgegeven, worden de actuele gegevens geleverd. Voor paginering, zie: [functionele specificatie paginering](https://github.com/lvbag/BAG-API/blob/master/Features/paginering.feature).
    # @param pand_identificatie [String] Identificatie van een object uit de BAG. Deze is 4 lang bij een woonplaats en 16 lang bij de andere objecten.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :huidig Indicatie dat alleen actuele object voorkomens zonder eindstatus gewenst zijn.
    # @option opts [Date] :geldig_op Filtert op objecten die geldig zijn op de opgegeven datum &#x60;JJJJ-MM-DD&#x60; Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Time] :beschikbaar_op Filtert op objecten die beschikbaar zijn op de opgegeven datum en tijd &#x60;YYYY-MM-DDThh:mm:ss.sss&#39; Hierin kunnen de seconden &#39;:ss&#39; en milliseconden &#39;.sss&#39; of alleen de milliseconden conform ISO 8601 specificatie worden weggelaten, in dat geval krijgen deze automatisch de waarde &#39;:00&#39; respectievelijk &#39;.000&#39;. Indien er voor de milliseconden &#39;.sss&#39; meer dan 3 cijfers worden opgegeven, bv. &#39;.12345&#39;, dan wordt dit afgekapt tot &#39;.123&#39;. Deze parameters komen uit de API strategie, het hoofdstuk tijdreizen. 
    # @option opts [Integer] :page Pagina nummer
    # @option opts [Integer] :page_size Aantal resultaten per pagina
    # @option opts [String] :accept_crs Gewenste CRS van de coördinaten in de response.
    # @return [Array<(VerblijfsobjectIOHalCollection, Integer, Hash)>] VerblijfsobjectIOHalCollection data, response status code and response headers
    def zoek_verblijfsobjecten_with_http_info(pand_identificatie, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: VerblijfsobjectApi.zoek_verblijfsobjecten ...'
      end
      # verify the required parameter 'pand_identificatie' is set
      if @api_client.config.client_side_validation && pand_identificatie.nil?
        fail ArgumentError, "Missing the required parameter 'pand_identificatie' when calling VerblijfsobjectApi.zoek_verblijfsobjecten"
      end
      pattern = Regexp.new(/^[0-9]{4}10[0-9]{10}$/)
      if @api_client.config.client_side_validation && pand_identificatie !~ pattern
        fail ArgumentError, "invalid value for 'pand_identificatie' when calling VerblijfsobjectApi.zoek_verblijfsobjecten, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'page'].nil? && opts[:'page'] < 1
        fail ArgumentError, 'invalid value for "opts[:"page"]" when calling VerblijfsobjectApi.zoek_verblijfsobjecten, must be greater than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 100
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling VerblijfsobjectApi.zoek_verblijfsobjecten, must be smaller than or equal to 100.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 10
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling VerblijfsobjectApi.zoek_verblijfsobjecten, must be greater than or equal to 10.'
      end

      allowable_values = ["epsg:28992"]
      if @api_client.config.client_side_validation && opts[:'accept_crs'] && !allowable_values.include?(opts[:'accept_crs'])
        fail ArgumentError, "invalid value for \"accept_crs\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/verblijfsobjecten'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'pandIdentificatie'] = pand_identificatie
      query_params[:'huidig'] = opts[:'huidig'] if !opts[:'huidig'].nil?
      query_params[:'geldigOp'] = opts[:'geldig_op'] if !opts[:'geldig_op'].nil?
      query_params[:'beschikbaarOp'] = opts[:'beschikbaar_op'] if !opts[:'beschikbaar_op'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'application/problem+json'])
      header_params[:'Accept-Crs'] = opts[:'accept_crs'] if !opts[:'accept_crs'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'VerblijfsobjectIOHalCollection'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKeyBAG']

      new_options = opts.merge(
        :operation => :"VerblijfsobjectApi.zoek_verblijfsobjecten",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VerblijfsobjectApi#zoek_verblijfsobjecten\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
