=begin
#IMBAG API - van de LVBAG

#Dit is de [BAG API](https://zakelijk.kadaster.nl/-/bag-api) Individuele Bevragingen van de Landelijke Voorziening Basisregistratie Adressen en Gebouwen (LVBAG).                                         <br/>                                         Meer informatie over de Basisregistratie Adressen en Gebouwen is te vinden op de website van het [Ministerie van Binnenlandse Zaken en Koninkrijksrelaties](https://www.geobasisregistraties.nl/basisregistraties/adressen-en-gebouwen) en [Kadaster](https://zakelijk.kadaster.nl/bag).                                         <br/>                                         <br/>                                         De BAG API levert informatie conform de [BAG Catalogus 2018](https://www.geobasisregistraties.nl/documenten/publicatie/2018/03/12/catalogus-2018) en het informatiemodel IMBAG 2.0.                                         De API specificatie volgt de [Nederlandse API-Strategie](https://docs.geostandaarden.nl/api/API-Strategie) specificatie versie van 20200204 en is opgesteld in [OpenAPI Specificatie](https://www.forumstandaardisatie.nl/standaard/openapi-specification) (OAS) v3.                                         <br/>                                         Het standaard mediatype HAL (`application/hal+json`) wordt gebruikt. Dit is een mediatype voor het weergeven van resources en hun relaties via hyperlinks.                                         <br/>                                         <br/>                                         Deze API is vooral gericht op individuele bevragingen (op basis van de identificerende gegevens van een object).                                         Om gebruik te kunnen maken van de BAG API is een API key nodig, deze kan verkregen worden door het [aanvraagformulier](https://formulieren.kadaster.nl/aanvraag_bag_api_individuele_bevragingen_productie) in te vullen.                                         <br/>                                         <br/>                                         Voor vragen, neem contact op met de LVBAG beheerder o.v.v. BAG API 2.0. We zijn aan het kijken naar een geschikt medium hiervoor, mede ook om de API iteratief te kunnen opstellen of doorontwikkelen samen met de community. Als de API iets (nog) niet kan, wat u wel graag wilt, neem dan contact op.

The version of the OpenAPI document: 2.1.6

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.4.0-SNAPSHOT

=end

require 'date'
require 'time'

module BagKadasterClient
  class AdresIO
    # Een naam die aan een openbare ruimte is toegekend in een daartoe strekkend formeel gemeentelijk besluit.
    attr_accessor :openbare_ruimte_naam

    # De officiële openbare ruimte naam als deze niet langer is dan 24 tekens of de volgens de NEN5825 verkorte naam van maximaal 24 tekens.
    attr_accessor :korte_naam

    # Een door of namens het gemeentebestuur ten aanzien van een adresseerbaar object toegekende nummering.
    attr_accessor :huisnummer

    # Een door of namens het gemeentebestuur ten aanzien van een adresseerbaar object toegekende toevoeging aan een huisnummer in de vorm van een alfanumeriek teken.
    attr_accessor :huisletter

    # Een door of namens het gemeentebestuur ten aanzien van een adresseerbaar object toegekende nadere toevoeging aan een huisnummer of een combinatie van huisnummer en huisletter.
    attr_accessor :huisnummertoevoeging

    # De door PostNL vastgestelde code behorende bij een bepaalde combinatie van een straatnaam en een huisnummer.
    attr_accessor :postcode

    # De benaming van een door het gemeentebestuur aangewezen woonplaats.
    attr_accessor :woonplaats_naam

    # Deze wordt gebruikt in de operation.
    attr_accessor :nummeraanduiding_identificatie

    # Deze wordt gebruikt in de operation.
    attr_accessor :openbare_ruimte_identificatie

    # De identificatie wordt gebruikt in de operation, bv. /woonplaatsen/3560. Waarde: 0001-9999, formaat: ^[0-9]{3}[1-9]\\|[0-9]{2}[1-9][0-9]\\|[0-9][1-9][0-9]{2}\\|[1-9][0-9]{3}$.
    attr_accessor :woonplaats_identificatie

    # Identificatie van een adresseerbaar object (ligplaats, standplaats of verblijfsobject) uit de BAG.
    attr_accessor :adresseerbaar_object_identificatie

    # Identificatie(s) van het pand of de panden waar het verblijfsobject deel van uit maakt.
    attr_accessor :pand_identificaties

    # Indicatie dat dit adres een nevenadres is van een adresseerbaar object. Het adres is een hoofdadres als deze indicatie niet wordt meegeleverd.
    attr_accessor :indicatie_nevenadres

    attr_accessor :geconstateerd

    attr_accessor :inonderzoek

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'openbare_ruimte_naam' => :'openbareRuimteNaam',
        :'korte_naam' => :'korteNaam',
        :'huisnummer' => :'huisnummer',
        :'huisletter' => :'huisletter',
        :'huisnummertoevoeging' => :'huisnummertoevoeging',
        :'postcode' => :'postcode',
        :'woonplaats_naam' => :'woonplaatsNaam',
        :'nummeraanduiding_identificatie' => :'nummeraanduidingIdentificatie',
        :'openbare_ruimte_identificatie' => :'openbareRuimteIdentificatie',
        :'woonplaats_identificatie' => :'woonplaatsIdentificatie',
        :'adresseerbaar_object_identificatie' => :'adresseerbaarObjectIdentificatie',
        :'pand_identificaties' => :'pandIdentificaties',
        :'indicatie_nevenadres' => :'indicatieNevenadres',
        :'geconstateerd' => :'geconstateerd',
        :'inonderzoek' => :'inonderzoek'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'openbare_ruimte_naam' => :'String',
        :'korte_naam' => :'String',
        :'huisnummer' => :'Integer',
        :'huisletter' => :'String',
        :'huisnummertoevoeging' => :'String',
        :'postcode' => :'String',
        :'woonplaats_naam' => :'String',
        :'nummeraanduiding_identificatie' => :'String',
        :'openbare_ruimte_identificatie' => :'String',
        :'woonplaats_identificatie' => :'String',
        :'adresseerbaar_object_identificatie' => :'String',
        :'pand_identificaties' => :'Array<String>',
        :'indicatie_nevenadres' => :'Boolean',
        :'geconstateerd' => :'Geconstateerd',
        :'inonderzoek' => :'AdresInOnderzoek'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # List of class defined in allOf (OpenAPI v3)
    def self.openapi_all_of
      [
      :'Adres',
      :'AdresIOAllOf'
      ]
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `BagKadasterClient::AdresIO` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `BagKadasterClient::AdresIO`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'openbare_ruimte_naam')
        self.openbare_ruimte_naam = attributes[:'openbare_ruimte_naam']
      end

      if attributes.key?(:'korte_naam')
        self.korte_naam = attributes[:'korte_naam']
      end

      if attributes.key?(:'huisnummer')
        self.huisnummer = attributes[:'huisnummer']
      end

      if attributes.key?(:'huisletter')
        self.huisletter = attributes[:'huisletter']
      end

      if attributes.key?(:'huisnummertoevoeging')
        self.huisnummertoevoeging = attributes[:'huisnummertoevoeging']
      end

      if attributes.key?(:'postcode')
        self.postcode = attributes[:'postcode']
      end

      if attributes.key?(:'woonplaats_naam')
        self.woonplaats_naam = attributes[:'woonplaats_naam']
      end

      if attributes.key?(:'nummeraanduiding_identificatie')
        self.nummeraanduiding_identificatie = attributes[:'nummeraanduiding_identificatie']
      end

      if attributes.key?(:'openbare_ruimte_identificatie')
        self.openbare_ruimte_identificatie = attributes[:'openbare_ruimte_identificatie']
      end

      if attributes.key?(:'woonplaats_identificatie')
        self.woonplaats_identificatie = attributes[:'woonplaats_identificatie']
      end

      if attributes.key?(:'adresseerbaar_object_identificatie')
        self.adresseerbaar_object_identificatie = attributes[:'adresseerbaar_object_identificatie']
      end

      if attributes.key?(:'pand_identificaties')
        if (value = attributes[:'pand_identificaties']).is_a?(Array)
          self.pand_identificaties = value
        end
      end

      if attributes.key?(:'indicatie_nevenadres')
        self.indicatie_nevenadres = attributes[:'indicatie_nevenadres']
      end

      if attributes.key?(:'geconstateerd')
        self.geconstateerd = attributes[:'geconstateerd']
      end

      if attributes.key?(:'inonderzoek')
        self.inonderzoek = attributes[:'inonderzoek']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @openbare_ruimte_naam.nil?
        invalid_properties.push('invalid value for "openbare_ruimte_naam", openbare_ruimte_naam cannot be nil.')
      end

      if @openbare_ruimte_naam.to_s.length > 80
        invalid_properties.push('invalid value for "openbare_ruimte_naam", the character length must be smaller than or equal to 80.')
      end

      if @openbare_ruimte_naam.to_s.length < 1
        invalid_properties.push('invalid value for "openbare_ruimte_naam", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if @openbare_ruimte_naam !~ pattern
        invalid_properties.push("invalid value for \"openbare_ruimte_naam\", must conform to the pattern #{pattern}.")
      end

      if !@korte_naam.nil? && @korte_naam.to_s.length > 24
        invalid_properties.push('invalid value for "korte_naam", the character length must be smaller than or equal to 24.')
      end

      if !@korte_naam.nil? && @korte_naam.to_s.length < 1
        invalid_properties.push('invalid value for "korte_naam", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if !@korte_naam.nil? && @korte_naam !~ pattern
        invalid_properties.push("invalid value for \"korte_naam\", must conform to the pattern #{pattern}.")
      end

      if @huisnummer.nil?
        invalid_properties.push('invalid value for "huisnummer", huisnummer cannot be nil.')
      end

      if @huisnummer > 99999
        invalid_properties.push('invalid value for "huisnummer", must be smaller than or equal to 99999.')
      end

      if @huisnummer < 1
        invalid_properties.push('invalid value for "huisnummer", must be greater than or equal to 1.')
      end

      pattern = Regexp.new(/^[a-zA-Z]{1}$/)
      if !@huisletter.nil? && @huisletter !~ pattern
        invalid_properties.push("invalid value for \"huisletter\", must conform to the pattern #{pattern}.")
      end

      pattern = Regexp.new(/^[0-9a-zA-Z]{1,4}$/)
      if !@huisnummertoevoeging.nil? && @huisnummertoevoeging !~ pattern
        invalid_properties.push("invalid value for \"huisnummertoevoeging\", must conform to the pattern #{pattern}.")
      end

      pattern = Regexp.new(/^[1-9]{1}[0-9]{3}[A-Z]{2}$/)
      if !@postcode.nil? && @postcode !~ pattern
        invalid_properties.push("invalid value for \"postcode\", must conform to the pattern #{pattern}.")
      end

      if @woonplaats_naam.nil?
        invalid_properties.push('invalid value for "woonplaats_naam", woonplaats_naam cannot be nil.')
      end

      if @woonplaats_naam.to_s.length > 80
        invalid_properties.push('invalid value for "woonplaats_naam", the character length must be smaller than or equal to 80.')
      end

      if @woonplaats_naam.to_s.length < 1
        invalid_properties.push('invalid value for "woonplaats_naam", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if @woonplaats_naam !~ pattern
        invalid_properties.push("invalid value for \"woonplaats_naam\", must conform to the pattern #{pattern}.")
      end

      if @nummeraanduiding_identificatie.nil?
        invalid_properties.push('invalid value for "nummeraanduiding_identificatie", nummeraanduiding_identificatie cannot be nil.')
      end

      if @nummeraanduiding_identificatie.to_s.length > 16
        invalid_properties.push('invalid value for "nummeraanduiding_identificatie", the character length must be smaller than or equal to 16.')
      end

      if @nummeraanduiding_identificatie.to_s.length < 16
        invalid_properties.push('invalid value for "nummeraanduiding_identificatie", the character length must be great than or equal to 16.')
      end

      pattern = Regexp.new(/^[0-9]{4}20[0-9]{10}$/)
      if @nummeraanduiding_identificatie !~ pattern
        invalid_properties.push("invalid value for \"nummeraanduiding_identificatie\", must conform to the pattern #{pattern}.")
      end

      if @openbare_ruimte_identificatie.nil?
        invalid_properties.push('invalid value for "openbare_ruimte_identificatie", openbare_ruimte_identificatie cannot be nil.')
      end

      if @openbare_ruimte_identificatie.to_s.length > 16
        invalid_properties.push('invalid value for "openbare_ruimte_identificatie", the character length must be smaller than or equal to 16.')
      end

      if @openbare_ruimte_identificatie.to_s.length < 16
        invalid_properties.push('invalid value for "openbare_ruimte_identificatie", the character length must be great than or equal to 16.')
      end

      pattern = Regexp.new(/^[0-9]{4}30[0-9]{10}$/)
      if @openbare_ruimte_identificatie !~ pattern
        invalid_properties.push("invalid value for \"openbare_ruimte_identificatie\", must conform to the pattern #{pattern}.")
      end

      if @woonplaats_identificatie.nil?
        invalid_properties.push('invalid value for "woonplaats_identificatie", woonplaats_identificatie cannot be nil.')
      end

      if @woonplaats_identificatie.to_s.length > 4
        invalid_properties.push('invalid value for "woonplaats_identificatie", the character length must be smaller than or equal to 4.')
      end

      if @woonplaats_identificatie.to_s.length < 4
        invalid_properties.push('invalid value for "woonplaats_identificatie", the character length must be great than or equal to 4.')
      end

      pattern = Regexp.new(/^[0-9]{3}[1-9]|[0-9]{2}[1-9][0-9]|[0-9][1-9][0-9]{2}|[1-9][0-9]{3}$/)
      if @woonplaats_identificatie !~ pattern
        invalid_properties.push("invalid value for \"woonplaats_identificatie\", must conform to the pattern #{pattern}.")
      end

      if !@adresseerbaar_object_identificatie.nil? && @adresseerbaar_object_identificatie.to_s.length > 16
        invalid_properties.push('invalid value for "adresseerbaar_object_identificatie", the character length must be smaller than or equal to 16.')
      end

      if !@adresseerbaar_object_identificatie.nil? && @adresseerbaar_object_identificatie.to_s.length < 16
        invalid_properties.push('invalid value for "adresseerbaar_object_identificatie", the character length must be great than or equal to 16.')
      end

      pattern = Regexp.new(/^[0-9]{4}(01|02|03)[0-9]{10}$/)
      if !@adresseerbaar_object_identificatie.nil? && @adresseerbaar_object_identificatie !~ pattern
        invalid_properties.push("invalid value for \"adresseerbaar_object_identificatie\", must conform to the pattern #{pattern}.")
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @openbare_ruimte_naam.nil?
      return false if @openbare_ruimte_naam.to_s.length > 80
      return false if @openbare_ruimte_naam.to_s.length < 1
      return false if @openbare_ruimte_naam !~ Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      return false if !@korte_naam.nil? && @korte_naam.to_s.length > 24
      return false if !@korte_naam.nil? && @korte_naam.to_s.length < 1
      return false if !@korte_naam.nil? && @korte_naam !~ Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      return false if @huisnummer.nil?
      return false if @huisnummer > 99999
      return false if @huisnummer < 1
      return false if !@huisletter.nil? && @huisletter !~ Regexp.new(/^[a-zA-Z]{1}$/)
      return false if !@huisnummertoevoeging.nil? && @huisnummertoevoeging !~ Regexp.new(/^[0-9a-zA-Z]{1,4}$/)
      return false if !@postcode.nil? && @postcode !~ Regexp.new(/^[1-9]{1}[0-9]{3}[A-Z]{2}$/)
      return false if @woonplaats_naam.nil?
      return false if @woonplaats_naam.to_s.length > 80
      return false if @woonplaats_naam.to_s.length < 1
      return false if @woonplaats_naam !~ Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      return false if @nummeraanduiding_identificatie.nil?
      return false if @nummeraanduiding_identificatie.to_s.length > 16
      return false if @nummeraanduiding_identificatie.to_s.length < 16
      return false if @nummeraanduiding_identificatie !~ Regexp.new(/^[0-9]{4}20[0-9]{10}$/)
      return false if @openbare_ruimte_identificatie.nil?
      return false if @openbare_ruimte_identificatie.to_s.length > 16
      return false if @openbare_ruimte_identificatie.to_s.length < 16
      return false if @openbare_ruimte_identificatie !~ Regexp.new(/^[0-9]{4}30[0-9]{10}$/)
      return false if @woonplaats_identificatie.nil?
      return false if @woonplaats_identificatie.to_s.length > 4
      return false if @woonplaats_identificatie.to_s.length < 4
      return false if @woonplaats_identificatie !~ Regexp.new(/^[0-9]{3}[1-9]|[0-9]{2}[1-9][0-9]|[0-9][1-9][0-9]{2}|[1-9][0-9]{3}$/)
      return false if !@adresseerbaar_object_identificatie.nil? && @adresseerbaar_object_identificatie.to_s.length > 16
      return false if !@adresseerbaar_object_identificatie.nil? && @adresseerbaar_object_identificatie.to_s.length < 16
      return false if !@adresseerbaar_object_identificatie.nil? && @adresseerbaar_object_identificatie !~ Regexp.new(/^[0-9]{4}(01|02|03)[0-9]{10}$/)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] openbare_ruimte_naam Value to be assigned
    def openbare_ruimte_naam=(openbare_ruimte_naam)
      if openbare_ruimte_naam.nil?
        fail ArgumentError, 'openbare_ruimte_naam cannot be nil'
      end

      if openbare_ruimte_naam.to_s.length > 80
        fail ArgumentError, 'invalid value for "openbare_ruimte_naam", the character length must be smaller than or equal to 80.'
      end

      if openbare_ruimte_naam.to_s.length < 1
        fail ArgumentError, 'invalid value for "openbare_ruimte_naam", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if openbare_ruimte_naam !~ pattern
        fail ArgumentError, "invalid value for \"openbare_ruimte_naam\", must conform to the pattern #{pattern}."
      end

      @openbare_ruimte_naam = openbare_ruimte_naam
    end

    # Custom attribute writer method with validation
    # @param [Object] korte_naam Value to be assigned
    def korte_naam=(korte_naam)
      if !korte_naam.nil? && korte_naam.to_s.length > 24
        fail ArgumentError, 'invalid value for "korte_naam", the character length must be smaller than or equal to 24.'
      end

      if !korte_naam.nil? && korte_naam.to_s.length < 1
        fail ArgumentError, 'invalid value for "korte_naam", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if !korte_naam.nil? && korte_naam !~ pattern
        fail ArgumentError, "invalid value for \"korte_naam\", must conform to the pattern #{pattern}."
      end

      @korte_naam = korte_naam
    end

    # Custom attribute writer method with validation
    # @param [Object] huisnummer Value to be assigned
    def huisnummer=(huisnummer)
      if huisnummer.nil?
        fail ArgumentError, 'huisnummer cannot be nil'
      end

      if huisnummer > 99999
        fail ArgumentError, 'invalid value for "huisnummer", must be smaller than or equal to 99999.'
      end

      if huisnummer < 1
        fail ArgumentError, 'invalid value for "huisnummer", must be greater than or equal to 1.'
      end

      @huisnummer = huisnummer
    end

    # Custom attribute writer method with validation
    # @param [Object] huisletter Value to be assigned
    def huisletter=(huisletter)
      pattern = Regexp.new(/^[a-zA-Z]{1}$/)
      if !huisletter.nil? && huisletter !~ pattern
        fail ArgumentError, "invalid value for \"huisletter\", must conform to the pattern #{pattern}."
      end

      @huisletter = huisletter
    end

    # Custom attribute writer method with validation
    # @param [Object] huisnummertoevoeging Value to be assigned
    def huisnummertoevoeging=(huisnummertoevoeging)
      pattern = Regexp.new(/^[0-9a-zA-Z]{1,4}$/)
      if !huisnummertoevoeging.nil? && huisnummertoevoeging !~ pattern
        fail ArgumentError, "invalid value for \"huisnummertoevoeging\", must conform to the pattern #{pattern}."
      end

      @huisnummertoevoeging = huisnummertoevoeging
    end

    # Custom attribute writer method with validation
    # @param [Object] postcode Value to be assigned
    def postcode=(postcode)
      pattern = Regexp.new(/^[1-9]{1}[0-9]{3}[A-Z]{2}$/)
      if !postcode.nil? && postcode !~ pattern
        fail ArgumentError, "invalid value for \"postcode\", must conform to the pattern #{pattern}."
      end

      @postcode = postcode
    end

    # Custom attribute writer method with validation
    # @param [Object] woonplaats_naam Value to be assigned
    def woonplaats_naam=(woonplaats_naam)
      if woonplaats_naam.nil?
        fail ArgumentError, 'woonplaats_naam cannot be nil'
      end

      if woonplaats_naam.to_s.length > 80
        fail ArgumentError, 'invalid value for "woonplaats_naam", the character length must be smaller than or equal to 80.'
      end

      if woonplaats_naam.to_s.length < 1
        fail ArgumentError, 'invalid value for "woonplaats_naam", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if woonplaats_naam !~ pattern
        fail ArgumentError, "invalid value for \"woonplaats_naam\", must conform to the pattern #{pattern}."
      end

      @woonplaats_naam = woonplaats_naam
    end

    # Custom attribute writer method with validation
    # @param [Object] nummeraanduiding_identificatie Value to be assigned
    def nummeraanduiding_identificatie=(nummeraanduiding_identificatie)
      if nummeraanduiding_identificatie.nil?
        fail ArgumentError, 'nummeraanduiding_identificatie cannot be nil'
      end

      if nummeraanduiding_identificatie.to_s.length > 16
        fail ArgumentError, 'invalid value for "nummeraanduiding_identificatie", the character length must be smaller than or equal to 16.'
      end

      if nummeraanduiding_identificatie.to_s.length < 16
        fail ArgumentError, 'invalid value for "nummeraanduiding_identificatie", the character length must be great than or equal to 16.'
      end

      pattern = Regexp.new(/^[0-9]{4}20[0-9]{10}$/)
      if nummeraanduiding_identificatie !~ pattern
        fail ArgumentError, "invalid value for \"nummeraanduiding_identificatie\", must conform to the pattern #{pattern}."
      end

      @nummeraanduiding_identificatie = nummeraanduiding_identificatie
    end

    # Custom attribute writer method with validation
    # @param [Object] openbare_ruimte_identificatie Value to be assigned
    def openbare_ruimte_identificatie=(openbare_ruimte_identificatie)
      if openbare_ruimte_identificatie.nil?
        fail ArgumentError, 'openbare_ruimte_identificatie cannot be nil'
      end

      if openbare_ruimte_identificatie.to_s.length > 16
        fail ArgumentError, 'invalid value for "openbare_ruimte_identificatie", the character length must be smaller than or equal to 16.'
      end

      if openbare_ruimte_identificatie.to_s.length < 16
        fail ArgumentError, 'invalid value for "openbare_ruimte_identificatie", the character length must be great than or equal to 16.'
      end

      pattern = Regexp.new(/^[0-9]{4}30[0-9]{10}$/)
      if openbare_ruimte_identificatie !~ pattern
        fail ArgumentError, "invalid value for \"openbare_ruimte_identificatie\", must conform to the pattern #{pattern}."
      end

      @openbare_ruimte_identificatie = openbare_ruimte_identificatie
    end

    # Custom attribute writer method with validation
    # @param [Object] woonplaats_identificatie Value to be assigned
    def woonplaats_identificatie=(woonplaats_identificatie)
      if woonplaats_identificatie.nil?
        fail ArgumentError, 'woonplaats_identificatie cannot be nil'
      end

      if woonplaats_identificatie.to_s.length > 4
        fail ArgumentError, 'invalid value for "woonplaats_identificatie", the character length must be smaller than or equal to 4.'
      end

      if woonplaats_identificatie.to_s.length < 4
        fail ArgumentError, 'invalid value for "woonplaats_identificatie", the character length must be great than or equal to 4.'
      end

      pattern = Regexp.new(/^[0-9]{3}[1-9]|[0-9]{2}[1-9][0-9]|[0-9][1-9][0-9]{2}|[1-9][0-9]{3}$/)
      if woonplaats_identificatie !~ pattern
        fail ArgumentError, "invalid value for \"woonplaats_identificatie\", must conform to the pattern #{pattern}."
      end

      @woonplaats_identificatie = woonplaats_identificatie
    end

    # Custom attribute writer method with validation
    # @param [Object] adresseerbaar_object_identificatie Value to be assigned
    def adresseerbaar_object_identificatie=(adresseerbaar_object_identificatie)
      if !adresseerbaar_object_identificatie.nil? && adresseerbaar_object_identificatie.to_s.length > 16
        fail ArgumentError, 'invalid value for "adresseerbaar_object_identificatie", the character length must be smaller than or equal to 16.'
      end

      if !adresseerbaar_object_identificatie.nil? && adresseerbaar_object_identificatie.to_s.length < 16
        fail ArgumentError, 'invalid value for "adresseerbaar_object_identificatie", the character length must be great than or equal to 16.'
      end

      pattern = Regexp.new(/^[0-9]{4}(01|02|03)[0-9]{10}$/)
      if !adresseerbaar_object_identificatie.nil? && adresseerbaar_object_identificatie !~ pattern
        fail ArgumentError, "invalid value for \"adresseerbaar_object_identificatie\", must conform to the pattern #{pattern}."
      end

      @adresseerbaar_object_identificatie = adresseerbaar_object_identificatie
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          openbare_ruimte_naam == o.openbare_ruimte_naam &&
          korte_naam == o.korte_naam &&
          huisnummer == o.huisnummer &&
          huisletter == o.huisletter &&
          huisnummertoevoeging == o.huisnummertoevoeging &&
          postcode == o.postcode &&
          woonplaats_naam == o.woonplaats_naam &&
          nummeraanduiding_identificatie == o.nummeraanduiding_identificatie &&
          openbare_ruimte_identificatie == o.openbare_ruimte_identificatie &&
          woonplaats_identificatie == o.woonplaats_identificatie &&
          adresseerbaar_object_identificatie == o.adresseerbaar_object_identificatie &&
          pand_identificaties == o.pand_identificaties &&
          indicatie_nevenadres == o.indicatie_nevenadres &&
          geconstateerd == o.geconstateerd &&
          inonderzoek == o.inonderzoek
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [openbare_ruimte_naam, korte_naam, huisnummer, huisletter, huisnummertoevoeging, postcode, woonplaats_naam, nummeraanduiding_identificatie, openbare_ruimte_identificatie, woonplaats_identificatie, adresseerbaar_object_identificatie, pand_identificaties, indicatie_nevenadres, geconstateerd, inonderzoek].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = BagKadasterClient.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
