=begin
#IMBAG API - van de LVBAG

#Dit is de [BAG API](https://zakelijk.kadaster.nl/-/bag-api) Individuele Bevragingen van de Landelijke Voorziening Basisregistratie Adressen en Gebouwen (LVBAG).                                         <br/>                                         Meer informatie over de Basisregistratie Adressen en Gebouwen is te vinden op de website van het [Ministerie van Binnenlandse Zaken en Koninkrijksrelaties](https://www.geobasisregistraties.nl/basisregistraties/adressen-en-gebouwen) en [Kadaster](https://zakelijk.kadaster.nl/bag).                                         <br/>                                         <br/>                                         De BAG API levert informatie conform de [BAG Catalogus 2018](https://www.geobasisregistraties.nl/documenten/publicatie/2018/03/12/catalogus-2018) en het informatiemodel IMBAG 2.0.                                         De API specificatie volgt de [Nederlandse API-Strategie](https://docs.geostandaarden.nl/api/API-Strategie) specificatie versie van 20200204 en is opgesteld in [OpenAPI Specificatie](https://www.forumstandaardisatie.nl/standaard/openapi-specification) (OAS) v3.                                         <br/>                                         Het standaard mediatype HAL (`application/hal+json`) wordt gebruikt. Dit is een mediatype voor het weergeven van resources en hun relaties via hyperlinks.                                         <br/>                                         <br/>                                         Deze API is vooral gericht op individuele bevragingen (op basis van de identificerende gegevens van een object).                                         Om gebruik te kunnen maken van de BAG API is een API key nodig, deze kan verkregen worden door het [aanvraagformulier](https://formulieren.kadaster.nl/aanvraag_bag_api_individuele_bevragingen_productie) in te vullen.                                         <br/>                                         <br/>                                         Voor vragen, neem contact op met de LVBAG beheerder o.v.v. BAG API 2.0. We zijn aan het kijken naar een geschikt medium hiervoor, mede ook om de API iteratief te kunnen opstellen of doorontwikkelen samen met de community. Als de API iets (nog) niet kan, wat u wel graag wilt, neem dan contact op.

The version of the OpenAPI document: 2.1.6

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.4.0-SNAPSHOT

=end

require 'date'
require 'time'

module BagKadasterClient
  class AdresUitgebreidInOnderzoekAllOf
    attr_accessor :type_adresseerbaar_object

    # Een indicatie dat de geometrie van het aan een adres gerelateerde adresseerbare object in onderzoek is.
    attr_accessor :adresseerbaar_object_geometrie

    # Een indicatie dat de status van het aan een adres gerelateerde adresseerbare object in onderzoek is.
    attr_accessor :adresseerbaar_object_status

    attr_accessor :adresseerbaar_objectheeft_als_hoofdadres

    attr_accessor :adresseerbaar_objectheeft_als_nevenadres

    attr_accessor :gebruiksdoelen

    attr_accessor :oppervlakte

    attr_accessor :maakt_deel_uit_van

    attr_accessor :oorspronkelijk_bouwjaar

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'type_adresseerbaar_object' => :'typeAdresseerbaarObject',
        :'adresseerbaar_object_geometrie' => :'adresseerbaarObjectGeometrie',
        :'adresseerbaar_object_status' => :'adresseerbaarObjectStatus',
        :'adresseerbaar_objectheeft_als_hoofdadres' => :'adresseerbaarObjectheeftAlsHoofdadres',
        :'adresseerbaar_objectheeft_als_nevenadres' => :'adresseerbaarObjectheeftAlsNevenadres',
        :'gebruiksdoelen' => :'gebruiksdoelen',
        :'oppervlakte' => :'oppervlakte',
        :'maakt_deel_uit_van' => :'maaktDeelUitVan',
        :'oorspronkelijk_bouwjaar' => :'oorspronkelijkBouwjaar'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'type_adresseerbaar_object' => :'Boolean',
        :'adresseerbaar_object_geometrie' => :'Boolean',
        :'adresseerbaar_object_status' => :'Boolean',
        :'adresseerbaar_objectheeft_als_hoofdadres' => :'Boolean',
        :'adresseerbaar_objectheeft_als_nevenadres' => :'Boolean',
        :'gebruiksdoelen' => :'Boolean',
        :'oppervlakte' => :'Boolean',
        :'maakt_deel_uit_van' => :'Boolean',
        :'oorspronkelijk_bouwjaar' => :'Boolean'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `BagKadasterClient::AdresUitgebreidInOnderzoekAllOf` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `BagKadasterClient::AdresUitgebreidInOnderzoekAllOf`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'type_adresseerbaar_object')
        self.type_adresseerbaar_object = attributes[:'type_adresseerbaar_object']
      end

      if attributes.key?(:'adresseerbaar_object_geometrie')
        self.adresseerbaar_object_geometrie = attributes[:'adresseerbaar_object_geometrie']
      end

      if attributes.key?(:'adresseerbaar_object_status')
        self.adresseerbaar_object_status = attributes[:'adresseerbaar_object_status']
      end

      if attributes.key?(:'adresseerbaar_objectheeft_als_hoofdadres')
        self.adresseerbaar_objectheeft_als_hoofdadres = attributes[:'adresseerbaar_objectheeft_als_hoofdadres']
      end

      if attributes.key?(:'adresseerbaar_objectheeft_als_nevenadres')
        self.adresseerbaar_objectheeft_als_nevenadres = attributes[:'adresseerbaar_objectheeft_als_nevenadres']
      end

      if attributes.key?(:'gebruiksdoelen')
        self.gebruiksdoelen = attributes[:'gebruiksdoelen']
      end

      if attributes.key?(:'oppervlakte')
        self.oppervlakte = attributes[:'oppervlakte']
      end

      if attributes.key?(:'maakt_deel_uit_van')
        self.maakt_deel_uit_van = attributes[:'maakt_deel_uit_van']
      end

      if attributes.key?(:'oorspronkelijk_bouwjaar')
        self.oorspronkelijk_bouwjaar = attributes[:'oorspronkelijk_bouwjaar']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          type_adresseerbaar_object == o.type_adresseerbaar_object &&
          adresseerbaar_object_geometrie == o.adresseerbaar_object_geometrie &&
          adresseerbaar_object_status == o.adresseerbaar_object_status &&
          adresseerbaar_objectheeft_als_hoofdadres == o.adresseerbaar_objectheeft_als_hoofdadres &&
          adresseerbaar_objectheeft_als_nevenadres == o.adresseerbaar_objectheeft_als_nevenadres &&
          gebruiksdoelen == o.gebruiksdoelen &&
          oppervlakte == o.oppervlakte &&
          maakt_deel_uit_van == o.maakt_deel_uit_van &&
          oorspronkelijk_bouwjaar == o.oorspronkelijk_bouwjaar
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [type_adresseerbaar_object, adresseerbaar_object_geometrie, adresseerbaar_object_status, adresseerbaar_objectheeft_als_hoofdadres, adresseerbaar_objectheeft_als_nevenadres, gebruiksdoelen, oppervlakte, maakt_deel_uit_van, oorspronkelijk_bouwjaar].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = BagKadasterClient.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
