=begin
#IMBAG API - van de LVBAG

#Dit is de [BAG API](https://zakelijk.kadaster.nl/-/bag-api) Individuele Bevragingen van de Landelijke Voorziening Basisregistratie Adressen en Gebouwen (LVBAG).                                         <br/>                                         Meer informatie over de Basisregistratie Adressen en Gebouwen is te vinden op de website van het [Ministerie van Binnenlandse Zaken en Koninkrijksrelaties](https://www.geobasisregistraties.nl/basisregistraties/adressen-en-gebouwen) en [Kadaster](https://zakelijk.kadaster.nl/bag).                                         <br/>                                         <br/>                                         De BAG API levert informatie conform de [BAG Catalogus 2018](https://www.geobasisregistraties.nl/documenten/publicatie/2018/03/12/catalogus-2018) en het informatiemodel IMBAG 2.0.                                         De API specificatie volgt de [Nederlandse API-Strategie](https://docs.geostandaarden.nl/api/API-Strategie) specificatie versie van 20200204 en is opgesteld in [OpenAPI Specificatie](https://www.forumstandaardisatie.nl/standaard/openapi-specification) (OAS) v3.                                         <br/>                                         Het standaard mediatype HAL (`application/hal+json`) wordt gebruikt. Dit is een mediatype voor het weergeven van resources en hun relaties via hyperlinks.                                         <br/>                                         <br/>                                         Deze API is vooral gericht op individuele bevragingen (op basis van de identificerende gegevens van een object).                                         Om gebruik te kunnen maken van de BAG API is een API key nodig, deze kan verkregen worden door het [aanvraagformulier](https://formulieren.kadaster.nl/aanvraag_bag_api_individuele_bevragingen_productie) in te vullen.                                         <br/>                                         <br/>                                         Voor vragen, neem contact op met de LVBAG beheerder o.v.v. BAG API 2.0. We zijn aan het kijken naar een geschikt medium hiervoor, mede ook om de API iteratief te kunnen opstellen of doorontwikkelen samen met de community. Als de API iets (nog) niet kan, wat u wel graag wilt, neem dan contact op.

The version of the OpenAPI document: 2.1.6

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.4.0-SNAPSHOT

=end

require 'date'
require 'time'

module BagKadasterClient
  class HistorieInOnderzoek
    # Het tijdstip waarop een versie van een onderzoek naar een attribuut van en BAG-object is geregistreerd in de registratie van een bronhouder en daarmee authentiek wordt gemaakt.
    attr_accessor :tijdstip_registratie

    # Het tijdstip waarop een versie van een onderzoek naar een attribuut van een BAG-object is beëindigd in de registratie van een bronhouder.
    attr_accessor :eind_registratie

    # De datum waarop een versie van een onderzoek naar een attribuut van een BAG-object geldig is in de werkelijkheid conform de ingangsdatum in het brondocument. Als er geen expliciete ingangsdatum van geldigheid is opgenomen, wordt de datum van het brondocument overgenomen.
    attr_accessor :begin_geldigheid

    # De datum waarop de periode van geldigheid van een versie van een onderzoek naar een attribuut van een BAG-object eindigt. Bijvoorbeeld als gevolg van de vaststelling van een nieuw brondocument. Wanneer er geen tijdstip is ingevuld, dan is de versie nog geldig.
    attr_accessor :eind_geldigheid

    # Dit is het tijdstip waarop een versie van een onderzoek naar een attribuut van een BAG-object is opgenomen in de registratie van de landelijke voorziening. De gegevens komen daarmee beschikbaar voor afnemers.
    attr_accessor :tijdstip_registratie_lv

    # Dit is het tijdstip waarop een versie van een onderzoek naar een attribuut van een BAG-object is beëindigd in de registratie van de landelijke voorziening.
    attr_accessor :tijdstip_eind_registratie_lv

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'tijdstip_registratie' => :'tijdstipRegistratie',
        :'eind_registratie' => :'eindRegistratie',
        :'begin_geldigheid' => :'beginGeldigheid',
        :'eind_geldigheid' => :'eindGeldigheid',
        :'tijdstip_registratie_lv' => :'tijdstipRegistratieLV',
        :'tijdstip_eind_registratie_lv' => :'tijdstipEindRegistratieLV'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'tijdstip_registratie' => :'Time',
        :'eind_registratie' => :'Time',
        :'begin_geldigheid' => :'Date',
        :'eind_geldigheid' => :'Date',
        :'tijdstip_registratie_lv' => :'Time',
        :'tijdstip_eind_registratie_lv' => :'Time'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `BagKadasterClient::HistorieInOnderzoek` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `BagKadasterClient::HistorieInOnderzoek`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'tijdstip_registratie')
        self.tijdstip_registratie = attributes[:'tijdstip_registratie']
      end

      if attributes.key?(:'eind_registratie')
        self.eind_registratie = attributes[:'eind_registratie']
      end

      if attributes.key?(:'begin_geldigheid')
        self.begin_geldigheid = attributes[:'begin_geldigheid']
      end

      if attributes.key?(:'eind_geldigheid')
        self.eind_geldigheid = attributes[:'eind_geldigheid']
      end

      if attributes.key?(:'tijdstip_registratie_lv')
        self.tijdstip_registratie_lv = attributes[:'tijdstip_registratie_lv']
      end

      if attributes.key?(:'tijdstip_eind_registratie_lv')
        self.tijdstip_eind_registratie_lv = attributes[:'tijdstip_eind_registratie_lv']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @tijdstip_registratie.nil?
        invalid_properties.push('invalid value for "tijdstip_registratie", tijdstip_registratie cannot be nil.')
      end

      if @begin_geldigheid.nil?
        invalid_properties.push('invalid value for "begin_geldigheid", begin_geldigheid cannot be nil.')
      end

      if @tijdstip_registratie_lv.nil?
        invalid_properties.push('invalid value for "tijdstip_registratie_lv", tijdstip_registratie_lv cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @tijdstip_registratie.nil?
      return false if @begin_geldigheid.nil?
      return false if @tijdstip_registratie_lv.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          tijdstip_registratie == o.tijdstip_registratie &&
          eind_registratie == o.eind_registratie &&
          begin_geldigheid == o.begin_geldigheid &&
          eind_geldigheid == o.eind_geldigheid &&
          tijdstip_registratie_lv == o.tijdstip_registratie_lv &&
          tijdstip_eind_registratie_lv == o.tijdstip_eind_registratie_lv
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [tijdstip_registratie, eind_registratie, begin_geldigheid, eind_geldigheid, tijdstip_registratie_lv, tijdstip_eind_registratie_lv].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = BagKadasterClient.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
