=begin
#IMBAG API - van de LVBAG

#Dit is de [BAG API](https://zakelijk.kadaster.nl/-/bag-api) Individuele Bevragingen van de Landelijke Voorziening Basisregistratie Adressen en Gebouwen (LVBAG).                                         <br/>                                         Meer informatie over de Basisregistratie Adressen en Gebouwen is te vinden op de website van het [Ministerie van Binnenlandse Zaken en Koninkrijksrelaties](https://www.geobasisregistraties.nl/basisregistraties/adressen-en-gebouwen) en [Kadaster](https://zakelijk.kadaster.nl/bag).                                         <br/>                                         <br/>                                         De BAG API levert informatie conform de [BAG Catalogus 2018](https://www.geobasisregistraties.nl/documenten/publicatie/2018/03/12/catalogus-2018) en het informatiemodel IMBAG 2.0.                                         De API specificatie volgt de [Nederlandse API-Strategie](https://docs.geostandaarden.nl/api/API-Strategie) specificatie versie van 20200204 en is opgesteld in [OpenAPI Specificatie](https://www.forumstandaardisatie.nl/standaard/openapi-specification) (OAS) v3.                                         <br/>                                         Het standaard mediatype HAL (`application/hal+json`) wordt gebruikt. Dit is een mediatype voor het weergeven van resources en hun relaties via hyperlinks.                                         <br/>                                         <br/>                                         Deze API is vooral gericht op individuele bevragingen (op basis van de identificerende gegevens van een object).                                         Om gebruik te kunnen maken van de BAG API is een API key nodig, deze kan verkregen worden door het [aanvraagformulier](https://formulieren.kadaster.nl/aanvraag_bag_api_individuele_bevragingen_productie) in te vullen.                                         <br/>                                         <br/>                                         Voor vragen, neem contact op met de LVBAG beheerder o.v.v. BAG API 2.0. We zijn aan het kijken naar een geschikt medium hiervoor, mede ook om de API iteratief te kunnen opstellen of doorontwikkelen samen met de community. Als de API iets (nog) niet kan, wat u wel graag wilt, neem dan contact op.

The version of the OpenAPI document: 2.1.6

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.4.0-SNAPSHOT

=end

require 'date'
require 'time'

module BagKadasterClient
  class LigplaatsAllOf
    # Deze wordt gebruikt in de operation.
    attr_accessor :identificatie

    # NL.IMBAG.Ligplaats
    attr_accessor :domein

    attr_accessor :status

    attr_accessor :geometrie

    attr_accessor :geconstateerd

    # De datum waarop het brondocument is vastgesteld, op basis waarvan een opname, mutatie of een verwijdering van gegevens ten aanzien van een object heeft plaatsgevonden.
    attr_accessor :documentdatum

    # De unieke aanduiding van het brondocument op basis waarvan een opname, mutatie of een verwijdering van gegevens ten aanzien van een woonplaats heeft plaatsgevonden, binnen een gemeente. Alle karakters uit de MES-1 karakterset zijn toegestaan.
    attr_accessor :documentnummer

    attr_accessor :voorkomen

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'identificatie' => :'identificatie',
        :'domein' => :'domein',
        :'status' => :'status',
        :'geometrie' => :'geometrie',
        :'geconstateerd' => :'geconstateerd',
        :'documentdatum' => :'documentdatum',
        :'documentnummer' => :'documentnummer',
        :'voorkomen' => :'voorkomen'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'identificatie' => :'String',
        :'domein' => :'String',
        :'status' => :'StatusPlaats',
        :'geometrie' => :'Surface',
        :'geconstateerd' => :'Indicatie',
        :'documentdatum' => :'Date',
        :'documentnummer' => :'String',
        :'voorkomen' => :'Voorkomen'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `BagKadasterClient::LigplaatsAllOf` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `BagKadasterClient::LigplaatsAllOf`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'identificatie')
        self.identificatie = attributes[:'identificatie']
      end

      if attributes.key?(:'domein')
        self.domein = attributes[:'domein']
      end

      if attributes.key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.key?(:'geometrie')
        self.geometrie = attributes[:'geometrie']
      end

      if attributes.key?(:'geconstateerd')
        self.geconstateerd = attributes[:'geconstateerd']
      end

      if attributes.key?(:'documentdatum')
        self.documentdatum = attributes[:'documentdatum']
      end

      if attributes.key?(:'documentnummer')
        self.documentnummer = attributes[:'documentnummer']
      end

      if attributes.key?(:'voorkomen')
        self.voorkomen = attributes[:'voorkomen']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @identificatie.nil?
        invalid_properties.push('invalid value for "identificatie", identificatie cannot be nil.')
      end

      if @identificatie.to_s.length > 16
        invalid_properties.push('invalid value for "identificatie", the character length must be smaller than or equal to 16.')
      end

      if @identificatie.to_s.length < 16
        invalid_properties.push('invalid value for "identificatie", the character length must be great than or equal to 16.')
      end

      pattern = Regexp.new(/^[0-9]{4}02[0-9]{10}$/)
      if @identificatie !~ pattern
        invalid_properties.push("invalid value for \"identificatie\", must conform to the pattern #{pattern}.")
      end

      if @domein.nil?
        invalid_properties.push('invalid value for "domein", domein cannot be nil.')
      end

      if @domein.to_s.length < 1
        invalid_properties.push('invalid value for "domein", the character length must be great than or equal to 1.')
      end

      if @status.nil?
        invalid_properties.push('invalid value for "status", status cannot be nil.')
      end

      if @geometrie.nil?
        invalid_properties.push('invalid value for "geometrie", geometrie cannot be nil.')
      end

      if @geconstateerd.nil?
        invalid_properties.push('invalid value for "geconstateerd", geconstateerd cannot be nil.')
      end

      if @documentdatum.nil?
        invalid_properties.push('invalid value for "documentdatum", documentdatum cannot be nil.')
      end

      if @documentnummer.nil?
        invalid_properties.push('invalid value for "documentnummer", documentnummer cannot be nil.')
      end

      if @documentnummer.to_s.length > 40
        invalid_properties.push('invalid value for "documentnummer", the character length must be smaller than or equal to 40.')
      end

      if @documentnummer.to_s.length < 1
        invalid_properties.push('invalid value for "documentnummer", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if @documentnummer !~ pattern
        invalid_properties.push("invalid value for \"documentnummer\", must conform to the pattern #{pattern}.")
      end

      if @voorkomen.nil?
        invalid_properties.push('invalid value for "voorkomen", voorkomen cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @identificatie.nil?
      return false if @identificatie.to_s.length > 16
      return false if @identificatie.to_s.length < 16
      return false if @identificatie !~ Regexp.new(/^[0-9]{4}02[0-9]{10}$/)
      return false if @domein.nil?
      return false if @domein.to_s.length < 1
      return false if @status.nil?
      return false if @geometrie.nil?
      return false if @geconstateerd.nil?
      return false if @documentdatum.nil?
      return false if @documentnummer.nil?
      return false if @documentnummer.to_s.length > 40
      return false if @documentnummer.to_s.length < 1
      return false if @documentnummer !~ Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      return false if @voorkomen.nil?
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] identificatie Value to be assigned
    def identificatie=(identificatie)
      if identificatie.nil?
        fail ArgumentError, 'identificatie cannot be nil'
      end

      if identificatie.to_s.length > 16
        fail ArgumentError, 'invalid value for "identificatie", the character length must be smaller than or equal to 16.'
      end

      if identificatie.to_s.length < 16
        fail ArgumentError, 'invalid value for "identificatie", the character length must be great than or equal to 16.'
      end

      pattern = Regexp.new(/^[0-9]{4}02[0-9]{10}$/)
      if identificatie !~ pattern
        fail ArgumentError, "invalid value for \"identificatie\", must conform to the pattern #{pattern}."
      end

      @identificatie = identificatie
    end

    # Custom attribute writer method with validation
    # @param [Object] domein Value to be assigned
    def domein=(domein)
      if domein.nil?
        fail ArgumentError, 'domein cannot be nil'
      end

      if domein.to_s.length < 1
        fail ArgumentError, 'invalid value for "domein", the character length must be great than or equal to 1.'
      end

      @domein = domein
    end

    # Custom attribute writer method with validation
    # @param [Object] documentnummer Value to be assigned
    def documentnummer=(documentnummer)
      if documentnummer.nil?
        fail ArgumentError, 'documentnummer cannot be nil'
      end

      if documentnummer.to_s.length > 40
        fail ArgumentError, 'invalid value for "documentnummer", the character length must be smaller than or equal to 40.'
      end

      if documentnummer.to_s.length < 1
        fail ArgumentError, 'invalid value for "documentnummer", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/^[\u0020-\u007E;\u00A0-\u00FF;\u0100-\u0113;\u0116-\u012B;\u012E-\u014D;\u0150-\u017E;\u02C7;\u02D8-\u02DB;\u02DD;\u2015;\u2018-\u2019;\u201C-\u201D;\u20AC;\u2122;\u2126;\u215B-\u215E;\u2190-\u2193;\u266A;]*/)
      if documentnummer !~ pattern
        fail ArgumentError, "invalid value for \"documentnummer\", must conform to the pattern #{pattern}."
      end

      @documentnummer = documentnummer
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          identificatie == o.identificatie &&
          domein == o.domein &&
          status == o.status &&
          geometrie == o.geometrie &&
          geconstateerd == o.geconstateerd &&
          documentdatum == o.documentdatum &&
          documentnummer == o.documentnummer &&
          voorkomen == o.voorkomen
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [identificatie, domein, status, geometrie, geconstateerd, documentdatum, documentnummer, voorkomen].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = BagKadasterClient.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
